'
'
'
'
'
'               Proprietary Code (c) 1999 Steven E Wright
'                               Open Source
'                          Theta Technologies Inc.
'                       http://thetatech.hypermart.net/
'
'                         CURRENT KERNEL VERSION:
'                               KER699-011
'                           CURRENT TSL VERSION:
'                               TSL699-007
'                           CURRENT FILE SYSTEM:
'                               TFS699-002
'
'                               For Lindsey
'
'TODO:
'Optimize Window Refresh
'Fix TGO! Directory Finding
'Optimize Imported Global Settings
'Window 'Objects'
'
DECLARE SUB RefWindows (BG%, win%)
DECLARE FUNCTION WindowsGet$ (x%, Labels$)
DECLARE SUB MapEMS (Handle%, pageoffset%)
DECLARE SUB ReleaseEMS (Handle%)
DECLARE FUNCTION EMSPages% (func%)
DECLARE FUNCTION EMSstatus% ()
DECLARE FUNCTION GetEMS% (numpages%)
DECLARE FUNCTION NumEMSHandles% ()
DECLARE FUNCTION NumEMSPages% (Handle%)
DECLARE FUNCTION PageFrame% ()
DECLARE SUB ActivateMenuMan ()
DECLARE SUB RunMenu ()
DECLARE SUB ActivateMenu ()
DECLARE SUB CheckMouseSecond ()
DECLARE SUB DoubleClicked (ico%)
DECLARE FUNCTION Permissions% (Filed$, type$)
DECLARE SUB ExecTSLCode (PID%, Prognum%, TGOPLCode$)
DECLARE SUB Login ()
DECLARE SUB Waitfor (Time!)
DECLARE SUB CloseProgramManual (PID%)
DECLARE SUB UnMaxWindowManual (PID%)
DECLARE SUB UnMinWindowManual (PID%)
DECLARE SUB FirstUsePart9 ()
DECLARE SUB MoveIcon (ico%)
DECLARE SUB MaxWindowManual (PID%)
DECLARE SUB HelpScreen ()
DECLARE SUB MinWindowManual (PID%)
DECLARE SUB MaxWindow (PID%)
DECLARE SUB MinWindow (PID%)
DECLARE FUNCTION MouseOnIcon% ()
DECLARE SUB RefIcoFile (ico%)
DECLARE SUB UnMaxWindow (PID%)
DECLARE SUB UnMinWindow (PID%)
DECLARE SUB CallSetAttrib (Commands$)
DECLARE SUB execprog (Filer$, ForceToPID%, ForceToProg%)
DECLARE SUB ClearVars (PID%)
DECLARE SUB StartUp (StartUpError%, Username$, Password$)
DECLARE SUB ErrorNu (ErrorNum%, SubName$)
DECLARE SUB VarValu (PID%, Name$, value$)
DECLARE SUB SetVarVal (PID%, Name$, NewValue$)
DECLARE SUB NewVar (PID%, Name$, type$, value$)
DECLARE SUB SizeWindowY (PID%)
DECLARE SUB SizeWindowX (PID%)
DECLARE SUB ClearOuts ()
DECLARE SUB logo ()
DECLARE SUB RefIcons ()
DECLARE SUB FIRSTUSE ()
DECLARE FUNCTION CurrentX% ()
DECLARE FUNCTION CurrentY% ()
DECLARE SUB mouse (CX%, DX%, BX%)
DECLARE SUB MoveWindow (PID%)
DECLARE SUB CloseProgram (PID%, Mode%)
DECLARE SUB ExitTGO ()
DECLARE SUB PrintToWin (PID%, Text$)
DECLARE SUB InitWin (PID%)
DECLARE SUB PrintButtons (XPositionB%, YPositionB%, XSizeB%)
DECLARE SUB CursorOff ()
DECLARE SUB cursorON ()
DECLARE SUB OutPutTo (FileName$, Variable$)
DECLARE SUB CloseF (FileName$)
DECLARE SUB InputFrom (FileName$, Variable$, Mode%)
DECLARE FUNCTION CheckOpen% (FileName$)
DECLARE SUB OpenF (FileAccess$, AccessType$, IgnoreNew%)
DECLARE FUNCTION GetFnum% (FileName$, ErrSwitch%)
DECLARE SUB cout (Text$, Xval%, Yval%, Col%)
DECLARE SUB KillPID ()
DECLARE SUB CurPrograms ()
DECLARE FUNCTION FreeWinManSP% ()
DECLARE SUB Scripter (PID%)
DECLARE SUB InitPalette ()
DECLARE FUNCTION WinWithPID% (PID%)
DECLARE SUB CloseWindow (PID%)
DECLARE SUB WindowsSort ()
DECLARE SUB ExecLineProg (PID%)
DECLARE FUNCTION ProgManWithPid% (PID%)
DECLARE SUB RunApps ()
DECLARE FUNCTION FreeAppletSP% ()
DECLARE SUB Interface ()
DECLARE FUNCTION FreeProgManSP% ()
DECLARE FUNCTION FreeIcoSP% ()
DECLARE SUB InitIcons ()
DECLARE SUB InitFont ()
DECLARE SUB Encrypt (Password$)
DECLARE SUB InputPassword (Password$, lineo%, colo%, colors%)
DECLARE SUB waitforinput ()
DECLARE SUB FirstUsePart8 ()
DECLARE SUB FirstUsePart7 ()
DECLARE SUB FirstUsePart6 ()
DECLARE SUB FirstUsePart4 ()
DECLARE SUB FirstUsePart5 ()
DECLARE SUB FirstUsePart2 ()
DECLARE SUB FirstUsePart1 ()
DECLARE SUB FirstUsePart3 ()
DECLARE SUB InitFiles ()
DECLARE SUB MousePointer (SW%)
DECLARE SUB InitMouse ()
DECLARE SUB ErrorHandler ()
DECLARE SUB Centered (Text$, LineOn%, Stoper%)
DECLARE SUB initscreen (ScreenNum%)
DECLARE SUB CheckMouseFirst ()
DECLARE FUNCTION MousePressed% ()

DEFINT A-Z

TYPE Program
	PID AS INTEGER                             'Program ID
	CurrentLine AS INTEGER                     'Current Line
	OSL AS INTEGER                             'Operating System Level
END TYPE

TYPE windows
	PosX AS INTEGER                            'Current X Position
	PosY AS INTEGER                            'Current Y Position
	oldXpos AS INTEGER
	oldYPos AS INTEGER
	Movable AS INTEGER                         'Movable Flag
			 
	SizX AS INTEGER                            'Current X Size
	SizY AS INTEGER                            'Current Y Size
	MaxX AS INTEGER                            'Maximum X Size
	MaxY AS INTEGER                            'Maximun Y Size
	MinX AS INTEGER                            'Minimum X Size
	MinY AS INTEGER                            'Minimum Y Size
			 
	PID AS INTEGER                             'PID Of Running App

	maxed AS INTEGER                           'Maximized Flag
	mined AS INTEGER                           'Minimized Flag

	TD AS SINGLE                               'Third Dimention

	OutF AS STRING * 255                       'Win Content

	PrintLine AS INTEGER                       'Content Line
END TYPE

CONST MaxApplets = 40                              'Maximum Applets
CONST true = -1, false = 0                         'Boolian Logic
CONST TGODirectory$ = ""                       'TGO! Active Directory
CONST TGODrive$ = ""                            'TGO! Active Drive
CONST CorrKERVers$ = "KER799-000"                  'Kernel Version
CONST CorrTSLVers$ = "TSL699-000"                  'TSL Version
CONST CorrTFSVers$ = "TFS699-000"                  'TFS Version
CONST WAoffset = 0                                 'Windows Array Offset
CONST AAoffset = 0                                 'Applets Array Offset
CONST PAoffset = 0                                 'Programs Array Offset

COMMON SHARED debug
COMMON SHARED Username$                            'Current UserName
COMMON SHARED RealName$
COMMON SHARED SSTimer                              'Time For The Screen Saver
COMMON SHARED BGRed                                'Red 0-60 BG Color
COMMON SHARED BGGreen                              'Green 0-60 BG Color
COMMON SHARED BGBlue                               'Blue 0-60 BG Color
COMMON SHARED ScreenX                              'Max X Pixels
COMMON SHARED ScreenY                              'Max Y Pixels
COMMON SHARED CX, BX, DX                           'Mouse Assm. Code
COMMON SHARED Choice$                              'KB input
COMMON SHARED StartActive                          'Start Menu Active?
COMMON SHARED StartDir$                            'Start Menu Directory
COMMON SHARED StdEmsHandle                         'EMS Handle
COMMON SHARED loggedin
COMMON SHARED sysrunlevel                          'System Run Level
							 '1.) _,-=RESERVED=-,_
							 '2.) Restart
							 '3.) Quit

'$DYNAMIC

DIM SHARED Applets$(1 TO MaxApplets, 1)            'FileName / Title For Apps
DIM SHARED Programs(1 TO MaxApplets) AS Program    'Scripting Sequencer
DIM SHARED windows(1 TO MaxApplets) AS windows     'Window Manager
DIM SHARED Variables$(1 TO MaxApplets, 0 TO 15)    'Variable Manager
							 'NOTE: SPACE 0 RESERVED

DIM SHARED Fonts(0 TO 127, 1 TO 8, 1 TO 16)        'Font

DIM SHARED ICONS$(25, 3)                           'Icons FileName / Link / X / Y

DIM SHARED asm(9)                                  'Mouse Routine Asm Code

DIM SHARED FilesOp$(255)                           'File Access Numbers

DIM SHARED Startmenu$(1 TO 2, 1 TO 20)

DIM SHARED newapp

newapp = 0

StartDir$ = "tgo"

SELECT CASE LCASE$(COMMAND$)
CASE ""
	debug = false
	help = 0
CASE "/debug"
	debug = true
CASE "/help"
	help = 1
CASE "/?"
	help = 1
'CASE ELSE
'        PRINT "tgo [/option]"
'        PRINT "/help or /?      |       Display Version Info"
'        PRINT "/debug           |       Runs Without Error Handler & With Extranious Info Printed"
'        PRINT LCASE$(COMMAND$); " Is An Invalid Option."
'        END
END SELECT

IF help = 1 THEN
	HelpScreen
	END
END IF

IF debug = false THEN ON ERROR GOTO ErrorHandler


CLS
PRINT "EXECUTING STARTUP SEQUENCE..."
PRINT "Version: "; CorrKERVers$
'PRINT "Extended Memory Services: ";
'IF EMSstatus = -1 THEN
'        PRINT "Installed"
'        PRINT "==============================================================================="
'        PRINT "Number of EMS Pages Avaliable: "; EMSPages(1)
'        PRINT "Number of EMS handles in use:"; NumEMSHandles
'        IF EMSPages(1) < 1024 THEN
'                CLS
'                PRINT "Not Enough EMS Provided, TGO! Needs 1024 Pages ("; LTRIM$(RTRIM$(STR$(1024 * 16))); "KB) Of EMS Memory."
'                PRINT "Terminal Error"
'                END
'        END IF
'        PRINT "Please Wait While EMS Storage Is Verified And Reserved"
'        PRINT "Verifying Avaliable..."
'        StdEmsHandle = GetEMS(EMSPages(1))      'Get ALL Avaliable Pages.
'        EMSsegment1 = PageFrame
'
'        PRINT "Verified."
'        PRINT "EMS Heap Opened."
'        MapEMS StdEmsHandle, 0
'        PRINT "EMS Handle Mapped."
'        PRINT "Page segment is at: "; HEX$(EMSsegment1)
'        PRINT "==============================================================================="
'ELSE
'        CLS
'        PRINT "EMS Not Detected"
'        PRINT "Terminal Error"
'        END
'END IF
PRINT "Loading..."

ON KEY(2) GOSUB 2000
ON KEY(3) GOSUB 3000
ON KEY(5) GOSUB 5000

'DO
	initscreen 12
	IF debug = true THEN
		PRINT "LOADING TGO!..."
		PRINT "     Mouse"
		InitMouse
		PRINT "     Files"
		InitFiles
		PRINT "     Font"
		InitFont
		PRINT "     Icons"
		InitIcons
		PRINT "     Palette"
		InitPalette
		PRINT "     Bad Shutdown Cleanup..."
		ClearOuts
	ELSE
		InitMouse
		InitFiles
		InitFont
		InitIcons
		InitPalette
		ClearOuts
	END IF
	CLS 0
	StartDir$ = "menu"
	MousePointer 1
	KEY(3) ON
	loggedin = 0
	Login
	RefWindows 1, -1

	FOR I = 1 TO 5
		KEY(I) ON                             'Enable Function Keys
	NEXT

	Interface

	FOR I = 1 TO 5
		KEY(I) OFF                             'Disable Function Keys
	NEXT
	SELECT CASE sysrunlevel
		CASE 0:
		CASE 1:
		CASE 2:
			ERASE Applets$
			ERASE windows
			ERASE Programs
			ERASE Fonts
			ERASE ICONS$
			ERASE asm
			sysrunlevel = 0
			Username$ = ""
		CASE 3': EXIT DO
		CASE ELSE:
			ERROR 105       'Invalid RunLevel Error
	END SELECT
'LOOP
COLOR 3
ExitTGO
END

ErrorHandler:
	CLS
	sysrunlevel = 2
	ErrorHandler
	RESUME
END

DATA 2,9,9,9,9,9,9,9,9,9,9,9,2
DATA 9,9,3,3,3,3,3,3,3,3,3,9,9
DATA 9,3,3,3,3,3,3,3,3,3,3,3,9
DATA 9,3,3,9,3,3,3,3,3,9,3,3,9
DATA 9,3,3,3,9,3,3,3,9,3,3,3,9
DATA 9,3,3,3,3,9,3,9,3,3,3,3,9
DATA 9,3,3,3,3,3,9,3,3,3,3,3,9
DATA 9,3,3,3,3,9,3,9,3,3,3,3,0
DATA 9,3,3,3,9,3,3,3,9,3,3,3,9
DATA 9,3,3,9,3,3,3,3,3,9,3,3,0
DATA 9,3,3,3,3,3,3,3,3,3,3,3,9
DATA 9,9,3,3,3,3,3,3,3,3,3,9,9
DATA 2,9,9,9,9,9,9,9,9,9,9,9,2

DATA 2,9,9,9,9,9,9,9,9,9,9,9,2
DATA 9,9,3,3,3,3,3,3,3,3,3,9,9
DATA 9,3,3,3,3,3,3,3,3,3,3,3,9
DATA 9,3,9,9,9,9,9,9,9,9,9,3,9
DATA 9,3,9,2,2,2,2,2,2,2,9,3,9
DATA 9,3,9,9,9,9,9,9,9,9,9,3,9
DATA 9,3,9,3,3,3,3,3,3,3,9,3,9
DATA 9,3,9,3,3,3,3,3,3,3,9,3,9
DATA 9,3,9,3,3,3,3,3,3,3,9,3,9
DATA 9,3,9,9,9,9,9,9,9,9,9,3,9
DATA 9,3,3,3,3,3,3,3,3,3,3,3,9
DATA 9,9,3,3,3,3,3,3,3,3,3,9,9
DATA 2,9,9,9,9,9,9,9,9,9,9,9,2

DATA 2,9,9,9,9,9,9,9,9,9,9,9,2
DATA 9,9,3,3,3,3,3,3,3,3,3,9,9
DATA 9,3,3,3,3,3,3,3,3,3,3,3,9
DATA 9,3,3,3,3,3,3,3,3,3,3,3,9
DATA 9,3,3,3,3,3,3,3,3,3,3,3,9
DATA 9,3,3,3,3,3,3,3,3,3,3,3,9
DATA 9,3,3,3,3,3,3,3,3,3,3,3,9
DATA 9,3,9,9,9,9,9,9,9,9,9,3,9
DATA 9,3,9,2,2,2,2,2,2,2,9,3,9
DATA 9,3,9,9,9,9,9,9,9,9,9,3,9
DATA 9,3,3,3,3,3,3,3,3,3,3,3,9
DATA 9,9,3,3,3,3,3,3,3,3,3,9,9
DATA 2,9,9,9,9,9,9,9,9,9,9,9,2

2000 :
sysrunlevel = 2
RETURN

3000 :
sysrunlevel = 3
RETURN

5000 :
CLS : RefWindows 1, -1: cursorON
RETURN

REM $STATIC
SUB ActivateMenu
IF loggedin = 1 THEN
IF StartActive = 1 THEN
	
	SHELL "dir menu\*.* /b /l > menu.dat"
			 
	FOR I = 1 TO 20
		Startmenu$(1, I) = ""
		Startmenu$(2, I) = ""
	NEXT
	
	FileAccess$ = "menu.dat"
	OpenF FileAccess$, "in", 1
	FOR I = 1 TO 20
		IF EOF(GetFnum(FileAccess$, 0)) THEN EXIT FOR
		InputFrom FileAccess$, NewFile$, 1
		Startmenu$(1, I) = StartDir$ + NewFile$
		Startmenu$(2, I) = NewFile$
	NEXT
	CloseF FileAccess$
			 
	RefWindows 1, -1
END IF
END IF

END SUB

SUB ActivateMenuMan
IF CurrentX < 50 AND CurrentY > 470 AND StartActive = 0 THEN
	StartDir$ = "menu\"
	StartActive = 1
	ActivateMenu
ELSE
	IF CurrentX < 50 AND CurrentY > 470 AND StartActive = 1 THEN
		StartActive = 0
		RefWindows 1, -1
		Waitfor .1
	END IF
END IF
END SUB

SUB CallSetAttrib (Commands$)

FOR I = 1 TO LEN(Commands$)
	IF MID$(Commands$, I, 2) = "::" THEN
		FOR Y = I TO LEN(Commands$)
			IF MID$(Commands$, Y, 2) = "::" THEN
				NFileName$ = MID$(Commands$, I + 2, Y)
				Oner$ = Username$
				Perms$ = MID$(Commands$, I + Y + 4, 3)
				CLS
				'cl 15
				PRINT "COMMANDS: "; Commands$
				PRINT "DATA: "; NFileName$ + "::" + Oner$ + "::" + Perms$
				PRINT ">: "; LEFT$(Perms$, 1), MID$(Perms$, 2, 1), RIGHT$(Perms$, 1)
				waitforinput
				'SetAttrib NFileName$, Oner$, LEFT$(Perms$, 1), MID$(Perms$, 2, 1), RIGHT$(Perms$, 1)
				EXIT FOR
			END IF
		NEXT
		EXIT FOR
	END IF
NEXT
END SUB

SUB Centered (Text$, LineOn, Stoper)
	LOCATE LineOn, (40 - ((LEN(Text$)) / 2))
	IF Stoper = 1 THEN PRINT Text$ ELSE PRINT Text$;
END SUB

SUB CheckMouseFirst
mouse CX, DX, BX
IF BX = 1 THEN
	ActivateMenuMan
	CursorOff
	FOR I = 1 TO UBOUND(Programs)
		Prognum = ProgManWithPid(I)
		IF Prognum > 0 THEN
		IF Programs(Prognum).PID > 0 THEN
			winnum = WinWithPID(I)
			IF winnum > 0 THEN
				SizeWindowX I
				SizeWindowY I
				MinWindowManual I
				MaxWindowManual I
				MoveWindow I
				CloseProgramManual I
			END IF
		END IF
		END IF
	NEXT
	FOR I = LBOUND(ICONS$) TO UBOUND(ICONS$)
		MoveIcon I
	NEXT
	cursorON
END IF


END SUB

SUB CheckMouseSecond
mouse CX, DX, BX
IF BX = 2 THEN
FOR x = LBOUND(ICONS$) TO FreeIcoSP - 1
	DoubleClicked x
NEXT
END IF
END SUB

FUNCTION CheckOpen (FileName$)
	CheckOpen = true
	FOR I = 1 TO 255
		IF LTRIM$(RTRIM$(LCASE$(FilesOp$(I)))) = LCASE$(FileName$) THEN
			CheckOpen = false
			EXIT FUNCTION
		END IF
	NEXT
END FUNCTION

SUB ClearOuts

SHELL "path = %PATH%;" + TGODrive$ + TGODirectory$
SHELL "dir /b /l > outs.dat"

FileAccess$ = "outs.dat"
OpenF FileAccess$, "in", 0
	DO
	IF EOF(GetFnum(FileAccess$, 0)) THEN EXIT DO
		InputFrom FileAccess$, IcoData$, 0
	IcoData$ = LCASE$(LTRIM$(RTRIM$(IcoData$)))

	IF RIGHT$(IcoData$, 3) = "tou" THEN
		PRINT "          Old Tou File Detected... Removing...";
		KILL IcoData$
		PRINT "DONE"
	END IF

	LOOP WHILE NOT (EOF(GetFnum(FileAccess$, 0)))
CloseF FileAccess$
KILL "outs.dat"

END SUB

SUB ClearVars (PID)
FOR I = 0 TO UBOUND(Variables$, 2)
	Variables$(PID, I) = ""
NEXT
END SUB

SUB CloseF (FileName$)
	FiNum = GetFnum(FileName$, 0)
	CLOSE #FiNum
	FilesOp$(FiNum) = ""
END SUB

SUB CloseProgram (PID, Mode)
				 
		'REMOVE PROGRAM MANAGER ENTERY
		Prognum = ProgManWithPid(PID)
		IF Prognum = 0 THEN EXIT SUB
		Programs(Prognum).PID = 0
		FileName$ = Applets$(PID, 0)
		Applets$(PID, 0) = ""
		Programs(Prognum).CurrentLine = 0
				
		'REMOVE THE PATH
		Applets$(PID, 1) = ""
			
		'CLOSE THE WINDOW
		ClearVars PID
		CloseWindow (PID)
			 
		'RefDesk
		CloseF FileName$
		IF Mode = 1 THEN RefWindows Mode, -1
END SUB

SUB CloseProgramManual (PID)
	winnum = WinWithPID(PID)
	IF CurrentX > windows(winnum).PosX + windows(winnum).SizX - 13 AND CurrentX < windows(winnum).PosX + windows(winnum).SizX THEN
		IF CurrentY > windows(winnum).PosY AND CurrentY < windows(winnum).PosY + 13 THEN
			CloseProgram PID, 1
			WindowsSort
		END IF
	END IF
END SUB

SUB CloseWindow (PID)
	winnum = WinWithPID(PID)
	IF winnum > 0 THEN
		IF NOT (CheckOpen(windows(winnum).OutF)) THEN
			CloseF windows(winnum).OutF
		END IF
		KILL RTRIM$(windows(winnum).OutF)
		windows(winnum).SizX = 0
		windows(winnum).SizY = 0
		windows(winnum).PosX = 0
		windows(winnum).PosY = 0
		windows(winnum).PID = 0
		windows(winnum).TD = 0
		windows(winnum).MinX = 0
		windows(winnum).MinY = 0
		windows(winnum).MaxX = 0
		windows(winnum).MaxY = 0
		windows(winnum).OutF = ""
		windows(winnum).mined = 0
		windows(winnum).maxed = 0
		Applets$(PID, 1) = ""
		WindowsSort
	END IF
END SUB

SUB CommandPrompt
	VIEW PRINT 29 TO 30
		PRINT "  Current Drive: "
		INPUT "  Command:\ ", Commands$
		IF NOT (Commands$ = "") THEN
		flag = 0
			IF LCASE$(LEFT$(Commands$, 4)) = "/run" THEN
				PRINT "EXECING PROG...."
				execprog RIGHT$(Commands$, LEN(Commands$) - 5), 0, 0
				flag = 1
			END IF

			IF LCASE$(LEFT$(Commands$, 10)) = "/setattrib" THEN
				CallSetAttrib (Commands$)
				flag = 1
			END IF


			IF LCASE$(RIGHT$(Commands$, 3)) = "ext" THEN
				PRINT "EXECING PROG...."
				execprog Commands$, 0, 0
				flag = 1
			END IF

			IF flag = 0 THEN
				SHELL Commands$
			END IF
		END IF
	VIEW PRINT 1 TO 30
END SUB

SUB cout (Text$, Xval, Yval, Col)

offset = 0
chcase = 3

FOR index = 1 TO LEN(Text$)
	current = ASC(RIGHT$(LEFT$(Text$, index), 1))  'Selects current
									 'charactor's ansi value
	IF (current = ASC("/")) THEN
		Yval = Yval + 16
		offset = index
	ELSE
		FOR Y = 1 TO 16
			FOR x = 1 TO 8
				IF Fonts(current, x, Y) <> 0 THEN
						PSET (Xval + x + ((index - offset) * 8), Yval + Y), Col'lower(current - 96, x, y)
				END IF
			NEXT
		NEXT
	END IF
NEXT


END SUB

SUB CurPrograms
	CLS
	FOR I = 1 TO UBOUND(Programs)
		Prognum = ProgManWithPid(I)
		IF Prognum > 0 THEN
		IF Programs(Prognum).PID > 0 THEN
			winnum = WinWithPID(I)
			IF winnum > 0 THEN
				PRINT " Title: "; Applets$(Programs(ProgManWithPid(I)).PID, 1);
				PRINT " TD: "; windows(winnum).TD
				Prognum = ProgManWithPid(I)
				PRINT "  PID: "; Programs(Prognum).PID;
				PRINT "  LINE: "; Programs(Prognum).CurrentLine;
				PRINT "  OSL: "; Programs(Prognum).OSL,
				PRINT LEFT$(LTRIM$(STR$(Programs(Prognum).OSL)), 1)
			END IF
		END IF
		END IF
	NEXT
END SUB

FUNCTION CurrentX
	mouse CX, DX, BX
	CurrentX = DX
END FUNCTION

FUNCTION CurrentY
	mouse CX, DX, BX
	CurrentY = CX
END FUNCTION

SUB CursorOff
	MousePointer 2
END SUB

SUB cursorON
	MousePointer 1
END SUB

SUB DoubleClicked (ico)

XPosition = VAL(ICONS$(ico, 2))
YPosition = VAL(ICONS$(ico, 3))
XSIZE = 20
YSize = 20
OffsetX = CurrentX - XPosition
OffsetY = CurrentY - YPosition

IF CurrentX > XPosition AND CurrentX < XPosition + XSIZE THEN
	IF CurrentY > YPosition AND CurrentY < YPosition + YSize THEN
		execprog ICONS$(ico, 1), 0, 0
		Waitfor .5
	END IF
END IF

END SUB

SUB Encrypt (Password$)
	IF Password$ > "" THEN
		FOR I = 1 TO LEN(Password$)
			Char1$ = MID$(Password$, I, 1)
			IF I - 1 = 0 THEN
			Char2$ = RIGHT$(Password$, 1)
			ELSE
			Char2$ = MID$(Password$, I - 1, 1)
			END IF
			FinalChar$ = LTRIM$(RTRIM$(STR$(ASC(Char1$) + ASC(Char2$))))
			EPassword$ = EPassword$ + FinalChar$ + "."
		NEXT
		EPassword$ = LEFT$(EPassword$, LEN(EPassword$) - 1)
		Password$ = EPassword$
	END IF
END SUB

SUB ErrorHandler
			 
			 
	initscreen 12
	COLOR 15
	PALETTE 0, 65536 * 60 + 256 * 0 + 0
	PALETTE 15, 65536 * 63 + 256 * 63 + 63

	Centered "TGO!", 5, 1
	Centered "ERROR ", 6, 1
	Centered "Error Code: ", 9, 0: PRINT STR$(ERR)
	Centered "Device Error Code: ", 10, 0: PRINT STR$(ERDEV)
	Centered "Device Name: ", 11, 0: PRINT ERDEV$
	Centered "Program Line: ", 12, 0: PRINT STR$(ERL)

	SELECT CASE ERR
	CASE 1
	A$ = "A NEXT WAS ENCOUNTERED WITHOUT A CORRESPONDING FOR"
	CASE 2
	A$ = "SYNTAX ERROR"
	CASE 3
	A$ = "A MISPLACED RETURN COMMAND"
	CASE 4
	A$ = "OUT OF DATA FOR A READ COMMAND"
	CASE 5
	A$ = "ILLEGAL USE OF A FUNCTION"
	CASE 75
	A$ = "PATH/FILE ACCESS ERROR... A DISK MAY BE WRITE PROTECTED"
	CASE 6
	A$ = "OVERFLOW"
	CASE 7
	A$ = "OUT OF MEMORY"
	CASE 8
	A$ = "UNDEFINED LINE NUMBER"
	CASE 9
	A$ = "SUBSCRIPT OUT OF RANGE"
	CASE 10
	A$ = "DUPLICATE DEFINITION"
	CASE 11
	A$ = "DIVISION BY 0"
	CASE 12
	A$ = "ILLEGAL DIRECT"
	CASE 13
	A$ = "TYPE MISMATCH"
	CASE 14
	A$ = "OUT OF STRING SPACE"
	CASE 15
	A$ = "STRING TO LOW"
	CASE 16
	A$ = "STRING FORMULA TOO COMPLEX"
	CASE 17
	A$ = "CANT CONTINUE"
	CASE 18
	A$ = "UNDEFINED USER FUNCTION"
	CASE 19
	A$ = "NO RESUME"
	CASE 20
	A$ = "RESUME WITHOUT AN ERROR"
	CASE 22
	A$ = "MISSING OPERAND"
	CASE 23
	A$ = "LINE BUFFER OVERFLOW"
	CASE 24
	A$ = "DEVICE TIMEOUT"
	CASE 25
	A$ = "PROBLEM WITH A DEVICE ATTACHED TO THE SYSTEM"
	CASE 26
	A$ = "ENCOUNTERED A FOR WITHOUT A NEXT"
	CASE 27
	A$ = "THE PRINTER IS OUT OF PAPER"
	CASE 29
	A$ = "WHILE WITHOUT WEND"
	CASE 30
	A$ = "WEND WITHOUT WHILE"
	CASE 50
	A$ = "FIELD OVERFLOW"
	CASE 51
	A$ = "INTERNAL ERROR"
	CASE 52
	A$ = "BAD FILE NUMBER"
	CASE 53
	A$ = "FILE NOT FOUND: " + FileAccess$
	CASE 54
	A$ = "BAD FILE MODE"
	CASE 55
	A$ = "FILE ALREADY OPEN: " + FileAccess$
	CASE 57
	A$ = "DEVICE I/O ERROR"
	CASE 58
	A$ = "FILE ALREADY EXISTS"
	CASE 61
	A$ = "DISK FULL"
	CASE 62
	A$ = "INPUT PAST END"
	CASE 63
	A$ = "BAD RECORD NUMBER"
	CASE 64
	A$ = "BAD FILE NAME"
	CASE 66
	A$ = "DIRECT STATEMENT IN FILE"
	CASE 67
	A$ = "TOO MANY FILES"
	CASE 68
	A$ = "DEVICE UNAVALIABLE"
	CASE 69
	A$ = "COMMUICATION BUFFER OVERFLOW"
	CASE 70
	A$ = "DISK WRITE PROTECTED"
	CASE 71
	A$ = "NO DISK IN THE DRIVE"
	CASE 72
	A$ = "DISK MEDIA ERROR"
	CASE 74
	A$ = "RENAME ACROSS DISKS"
	CASE 75
	A$ = "PATH FILE ACCESS ERROR"
	CASE 76
	A$ = "PATH NOT FOUND"
	CASE 101
	A$ = "TGO! Specific Error 101, No Remaining PIDs"
	CASE 102
	A$ = "TGO! Specific Error 102, Error In TSL Program"
	CASE 103
	A$ = "TGO! Specific Error 103, Invalid TSL Program Operating Level"
	CASE 104
	A$ = "TGO! Specific Error 104, Invalid TSL Program Applet Location"
	CASE 105
	A$ = "TGO! Specific Error 105, Invalid System Run Level"
	CASE 105
	A$ = "TGO! Specific Error 106, Invalid Screen Resolution"
	'106
	'107                    RESERVED FOR FUTURE USE
	'108
	CASE 109
	A$ = "TGO! Specific Error 109, Invalid InputFrom Mode"
	CASE 110
	A$ = "TGO! Specific Error 110, Invalid GetFNum File.. File Not Open"
	CASE ELSE
	A$ = "UNIDENTIYABLE ERROR"
	END SELECT

	Centered A$, 7, 1
	Centered "Press q To Exit, Or Any Other Key To Attempt To Continue.", 19, 1
	DO: B$ = INKEY$: LOOP WHILE B$ = ""
	IF LCASE$(B$) = "q" THEN
		PALETTE
		ExitTGO
	END IF
	PALETTE

END SUB

SUB ErrorNu (ErrorNum, SubName$)
SELECT CASE ErrorNum
	CASE 101
	A$ = "No Remaining PIDs"
	CASE 102
	A$ = "Error In TSL Program"
	CASE 103
	A$ = "Invalid TSL Program Operating Level"
	CASE 104
	A$ = "Invalid TSL Program Applet Location"
	CASE 105
	A$ = "Invalid System Run Level"
	CASE 106
	A$ = "Invalid Screen Resolution"
	CASE 107
	A$ = "Invalid Username Password Combination"
	CASE 108
	A$ = "Invalid TSL Program Command Encountered"
	CASE 109
	A$ = "Invalid InputFrom Mode"
	CASE 110
	A$ = "Invalid GetFNum File.. File Not Open"
	CASE 111
	A$ = "No Corresponding Line In TSL GOTO Command."
	CASE 112
	A$ = "Var Not Declared In TSL Program."
	CASE ELSE
	A$ = "UNIDENTIYABLE ERROR"
END SELECT
FileAccess$ = TGODrive$ + TGODirectory$ + "error.ext"
OpenF FileAccess$, "out", 1
OutPutTo FileAccess$, "header"
OutPutTo FileAccess$, "tsl"
OutPutTo FileAccess$, CorrKERVers$
OutPutTo FileAccess$, "011"
OutPutTo FileAccess$, ""
OutPutTo FileAccess$, "awin"
OutPutTo FileAccess$, "title: TGO! Error"
OutPutTo FileAccess$, "xpos: 50"
OutPutTo FileAccess$, "ypos: 100"
OutPutTo FileAccess$, "xsize: 500"
OutPutTo FileAccess$, "ysize: 75"
OutPutTo FileAccess$, "minx: 50"
OutPutTo FileAccess$, "miny: 75"
OutPutTo FileAccess$, "stop"
OutPutTo FileAccess$, ""
OutPutTo FileAccess$, "cout"
OutPutTo FileAccess$, "ERROR: " + STR$(ErrorNum) + " : "
OutPutTo FileAccess$, LTRIM$(RTRIM$(A$))
OutPutTo FileAccess$, "/From Sub: "
OutPutTo FileAccess$, LTRIM$(RTRIM$(SubName$))
OutPutTo FileAccess$, "stop"
OutPutTo FileAccess$, ""
OutPutTo FileAccess$, "hold"
OutPutTo FileAccess$, ""
OutPutTo FileAccess$, "end"
CloseF FileAccess$
execprog FileAccess$, 0, 0
END SUB

SUB ExecLineProg (PID)

	IF LTRIM$(RTRIM$(Applets$(PID, 0))) = "" THEN ErrorNu 104, "EXECLINEPROG"
	Prognum = ProgManWithPid(PID)
	OpenF Applets$(PID, 0), "in", 1
			 
	FOR I = 0 TO Programs(Prognum).CurrentLine - 1
		InputFrom Applets$(PID, 0), Scrap$, 1
	NEXT
			
		InputFrom Applets$(PID, 0), TGOPLCode$, 1
		TGOPLCode$ = LTRIM$(RTRIM$(TGOPLCode$))
		ExecTSLCode PID, Prognum, TGOPLCode$
IF Applets$(PID, 0) > "" THEN CloseF Applets$(PID, 0)
Programs(Prognum).CurrentLine = Programs(Prognum).CurrentLine + 1
END SUB

SUB execprog (Filer$, ForceToPID, ForceToProg)
'Check The Existance Of the Filer$
	OpenF Filer$, "bin", 1
	IF LOF(GetFnum(Filer$, 0)) = 0 THEN
		ErrorNu 114, "EXECPROG/TSL File Not Found."
		EXIT SUB
	END IF
	CloseF Filer$
	IF LCASE$(RIGHT$(Filer$, 4)) <> ".ext" AND LCASE$(RIGHT$(Filer$, 4)) <> ".lnk" THEN
		ErrorNu 115, "EXECPROG/Invalid TSL Program."
		EXIT SUB
	END IF
	IF LCASE$(RIGHT$(Filer$, 4)) = ".lnk" THEN
		ErrorNu 120, "Auto-Link Execution Currently Unsuported"
		EXIT SUB
	END IF
	OpenF Filer$, "in", 0
		InputFrom Filer$, header$, 1
		InputFrom Filer$, Tsl$, 1
		InputFrom Filer$, Domain$, 1
		InputFrom Filer$, SubDomain$, 1
		cona = (header$ <> "header")
		conb = (Tsl$ <> "tsl")
		conc = (MID$(Domain$, 4, 3) > MID$(CorrKERVers$, 4, 3))
	CloseF Filer$
	IF cona OR conb OR conc THEN
		ErrorNu 121, "Coded In An Invalid TSL Version"
		EXIT SUB
	END IF

'Start Exec
	IF ForceToPID > 0 THEN
		PID = ForceToPID
	ELSE
		PID = FreeAppletSP
	END IF
	IF ForceToProg > 0 THEN
		NC = ForceToProg
	ELSE
		NC = FreeProgManSP
	END IF
	Programs(NC).CurrentLine = 5
	Programs(NC).PID = PID
	Programs(NC).OSL = 0
	Applets$(PID, 0) = Filer$
	Applets$(PID, 1) = Filer$
END SUB

SUB ExecTSLCode (PID, Prognum, TGOPLCode$)
SELECT CASE LCASE$(TGOPLCode$)
CASE "layout"

CASE "if"
	InputFrom Applets$(PID, 0), value$, 1
	Programs(Prognum).CurrentLine = Programs(Prognum).CurrentLine + 1
	SELECT CASE value$
	CASE "assert"
		TruthVal = 1
	CASE "not"
		TruthVal = -1
	END SELECT
	InputFrom Applets$(PID, 0), Conditional$, 1
	Programs(Prognum).CurrentLine = Programs(Prognum).CurrentLine + 1
	InputFrom Applets$(PID, 0), NewCond$, 1
	Programs(Prognum).CurrentLine = Programs(Prognum).CurrentLine + 1
	IF LEFT$(NewCond$, 1) = "&" THEN
		VarValu PID, RIGHT$(NewCond$, LEN(NewCond$) - 1), NewCond$
	END IF
	IF Conditional$ = "equals" THEN
		Mustequal$ = LTRIM$(LCASE$(RTRIM$(NewCond$)))
		CurrentTruth = 1
	END IF
	IF Conditional$ = "and" THEN
		InputFrom Applets$(PID, 0), NewCond2$, 1
		Programs(Prognum).CurrentLine = Programs(Prognum).CurrentLine + 1
		CurrentTruth = VAL(LTRIM$(LCASE$(RTRIM$(NewCond$)))) AND VAL(LTRIM$(LCASE$(RTRIM$(NewCond2$))))
	END IF
	IF Conditional$ = "or" THEN
		InputFrom Applets$(PID, 0), NewCond2$, 1
		Programs(Prognum).CurrentLine = Programs(Prognum).CurrentLine + 1
		CurrentTruth = VAL(LTRIM$(LCASE$(RTRIM$(NewCond$)))) OR VAL(LTRIM$(LCASE$(RTRIM$(NewCond2$))))
	END IF

	DO
		InputFrom Applets$(PID, 0), NewCond$, 1
		Programs(Prognum).CurrentLine = Programs(Prognum).CurrentLine + 1
		IF LEFT$(NewCond$, 1) = "&" THEN
			VarValu PID, RIGHT$(NewCond$, LEN(NewCond$) - 1), NewCond$
		END IF
		IF LTRIM$(LCASE$(RTRIM$(NewCond$))) = "then" THEN EXIT DO
		SELECT CASE Conditional$
		CASE "and"
			CurrentTruth = CurrentTruth AND VAL(LTRIM$(LCASE$(RTRIM$(NewCond$))))
		CASE "or"
			CurrentTruth = CurrentTruth OR VAL(LTRIM$(LCASE$(RTRIM$(NewCond$))))
		CASE "equals"
			IF Mustequal$ <> LTRIM$(LCASE$(RTRIM$(NewCond$))) THEN CurrentTruth = 0
		END SELECT
	LOOP
	IF TruthVal = -1 THEN CurrentTruth = NOT (CurrentTruth)
	IF CurrentTruth = 0 THEN
		DO
			InputFrom Applets$(PID, 0), NewCond$, 1
			Programs(Prognum).CurrentLine = Programs(Prognum).CurrentLine + 1
			IF NewCond$ = "endif" THEN EXIT DO
		LOOP
	ELSE
	END IF
CASE "execprog"
	InputFrom Applets$(PID, 0), Progname$, 1
	PRINT Progname$
	SLEEP
	VarValu PID, Progname$, Progname$
	'StartActive = 0
	
	
	execprog Progname$, 5, 5
	newapp = 1
CASE "goto"
	InputFrom Applets$(PID, 0), targetline$, 1
	CloseF Applets$(PID, 0)
	OpenF Applets$(PID, 0), "in", 0
	PX = Programs(Prognum).CurrentLine
	x = 0
	DO WHILE NOT (EOF(GetFnum(Applets$(PID, 0), 0)))
		x = x + 1
		InputFrom Applets$(PID, 0), NewLine$, 1
		IF LTRIM$(RTRIM$(LCASE$(NewLine$))) = LTRIM$(RTRIM$(LCASE$(targetline$))) + ":" THEN
			Programs(Prognum).CurrentLine = x
			EXIT DO
		END IF
	LOOP
	IF EOF(GetFnum(Applets$(PID, 0), 0)) THEN
		ErrorNu 111, "EXECLINEPROG"
		Programs(Prognum).CurrentLine = PX
	END IF
CASE "enc"
	InputFrom Applets$(PID, 0), Password$, 1
	PasswordN$ = Password$
	VarValu PID, Password$, Password$
	Encrypt Password$
	SetVarVal PID, PasswordN$, Password$
CASE "equals"
	InputFrom Applets$(PID, 0), Variable1$, 1
	InputFrom Applets$(PID, 0), Variable2$, 1
	IF LEFT$(Variable2$, 1) = CHR$(34) THEN
		SetVarVal PID, Variable1$, Variable2$
	ELSE
		VarValu PID, Variable2$, Variable2$
		SetVarVal PID, Variable1$, Variable2$
	END IF
CASE "writeto"
	InputFrom Applets$(PID, 0), TSLFileName$, 1
	OpenF TSLFileName$, "out", 1
	DO
		InputFrom Applets$(PID, 0), VarName$, 1
		IF VarName$ = "stop" THEN EXIT DO
		IF LEFT$(VarName$, 1) = CHR$(34) THEN                   '(")
			OutPutTo TSLFileName$, RIGHT$(VarName$, LEN(VarName$) - 1)
		ELSE
			VarValu PID, VarName$, VarValue$
			OutPutTo TSLFileName$, VarValue$
		END IF
	LOOP
	CloseF TSLFileName$
CASE "appto"
	InputFrom Applets$(PID, 0), TSLFileName$, 1
	OpenF TSLFileName$, "app", 1
	DO
		InputFrom Applets$(PID, 0), VarName$, 1
		IF VarName$ = "stop" THEN EXIT DO
		IF LEFT$(VarName$, 1) = CHR$(34) THEN                   '(")
			OutPutTo TSLFileName$, RIGHT$(VarName$, LEN(VarName$) - 1)
		ELSE
			VarValu PID, VarName$, VarValue$
			OutPutTo TSLFileName$, VarValue$
		END IF
	LOOP
	CloseF TSLFileName$
CASE "infrom"
	InputFrom Applets$(PID, 0), TSLFileName$, 1
	OpenF TSLFileName$, "in", 1
	DO
		IF VarName$ = "stop" THEN EXIT DO
		InputFrom TSLFileName$, VarValue$, 1
		InputFrom Applets$(PID, 0), VarName$, 1
		SetVarVal PID, VarName$, VarValue$
	LOOP
	CloseF TSLFileName$
CASE "incpl"
	windows(winnum).PrintLine = windows(winnum).PrintLine + 1
CASE "awin":
			InitWin PID
			CW = WinWithPID(PID)
			DO
				InputFrom Applets$(PID, 0), tempcode$, 1
				Programs(Prognum).CurrentLine = Programs(Prognum).CurrentLine + 1
				tempcode$ = (LTRIM$(RTRIM$(tempcode$)))
				IF LCASE$(tempcode$) = "stop" THEN EXIT DO
				FOR cyc = 1 TO LEN(tempcode$)
					IF MID$(tempcode$, cyc, 1) = ":" THEN
						TempCommand$ = (LTRIM$(RTRIM$(LEFT$(tempcode$, cyc))))
					END IF
				NEXT cyc
				SELECT CASE LCASE$(TempCommand$)
					CASE "title:": Applets$(PID, 1) = LTRIM$(RTRIM$(RIGHT$(tempcode$, LEN(tempcode$) - LEN(TempCommand$))))
					CASE "xloc:": windows(CW).PosX = VAL(LTRIM$(RTRIM$(RIGHT$(tempcode$, LEN(tempcode$) - LEN(TempCommand$)))))
					CASE "yloc:": windows(CW).PosY = VAL(LTRIM$(RTRIM$(RIGHT$(tempcode$, LEN(tempcode$) - LEN(TempCommand$)))))
					CASE "xsize:": windows(CW).SizX = VAL(LTRIM$(RTRIM$(RIGHT$(tempcode$, LEN(tempcode$) - LEN(TempCommand$)))))
					CASE "ysize:": windows(CW).SizY = VAL(LTRIM$(RTRIM$(RIGHT$(tempcode$, LEN(tempcode$) - LEN(TempCommand$)))))
					CASE "miny:": windows(CW).MinY = VAL(LTRIM$(RTRIM$(RIGHT$(tempcode$, LEN(tempcode$) - LEN(TempCommand$)))))
					CASE "minx:": windows(CW).MinX = VAL(LTRIM$(RTRIM$(RIGHT$(tempcode$, LEN(tempcode$) - LEN(TempCommand$)))))
					CASE "maxx:": windows(CW).MaxX = VAL(LTRIM$(RTRIM$(RIGHT$(tempcode$, LEN(tempcode$) - LEN(TempCommand$)))))
					CASE "maxy:": windows(CW).MaxY = VAL(LTRIM$(RTRIM$(RIGHT$(tempcode$, LEN(tempcode$) - LEN(TempCommand$)))))
				END SELECT
			LOOP
			RefWindows 1, -1
CASE "cout"
			winnum = WinWithPID(PID)
			DO
			InputFrom Applets$(PID, 0), TempCommand$, 1
				IF LCASE$(TempCommand$) <> "stop" THEN
					IF LEFT$(TempCommand$, 1) = "&" THEN
						VariVal$ = RIGHT$(TempCommand$, LEN(TempCommand$) - 1)
						VarValu PID, VariVal$, value$
						PrintToWin PID, value$
					ELSE
						PrintToWin PID, TempCommand$
					END IF
				END IF
			LOOP UNTIL LCASE$(TempCommand$) = "stop"
CASE "hold"
			Programs(Prognum).OSL = 4
CASE "wait"
			Programs(Prognum).OSL = VAL("310" + RIGHT$(TIME$, 2))
			DO
				InputFrom Applets$(PID, 0), tempcode$, 1
				Programs(Prognum).CurrentLine = Programs(Prognum).CurrentLine + 1
				tempcode$ = LTRIM$(RTRIM$(tempcode$))
			IF tempcode$ = "stop" THEN EXIT DO
				 
			FOR cyc = 1 TO LEN(tempcode$)
				IF MID$(tempcode$, cyc, 1) = ":" THEN
					TempCommand$ = LTRIM$(RTRIM$(LEFT$(tempcode$, cyc)))
				END IF
			NEXT cyc
				IF TempCommand$ = "time:" THEN Programs(Prognum).OSL = VAL("3" + LTRIM$(RTRIM$(RIGHT$(tempcode$, LEN(tempcode$) - LEN(TempCommand$)))) + RIGHT$(TIME$, 2))
			LOOP
CASE "initvar"
			DO
				InputFrom Applets$(PID, 0), tempcode$, 1
				tempcode$ = LCASE$(LTRIM$(RTRIM$(tempcode$)))
				IF tempcode$ <> "stop" THEN
					NewVar PID, tempcode$, "$", ""
				END IF
			LOOP UNTIL tempcode$ = "stop"
CASE "input"
			winnum = WinWithPID(PID)
			InputFrom Applets$(PID, 0), tempcode$, 1
			Programs(Prognum).OSL = 5
			Variables$(PID, 0) = tempcode$
			windows(winnum).PrintLine = windows(winnum).PrintLine + 1
			PrintToWin PID, " "
			RefWindows 1, -1
			RefWindows 1, -1
CASE "exit": sysrunlevel = 3
CASE "closewindow": CloseWindow PID

CASE "shell"
  InputFrom Applets$(PID, 0), ShellApp$, 1
  SHELL ShellApp$
CASE "end": CloseProgram PID, 0: RefWindows 1, -1
END SELECT

END SUB

SUB ExitTGO
	CursorOff
	END
	PRINT "Please Wait While M-OS Shuts Down."
	'PRINT "please note that this is an important process... do not interupt it, or you may not be able to run programs without rebooting your computer."
	PRINT
	IF debug = true THEN PRINT "     CLOSING ALL PROGRAMS..."
	FOR I = 1 TO UBOUND(Programs)
		Prognum = ProgManWithPid(I)
		IF Prognum > 0 THEN
		IF Programs(Prognum).PID > 0 THEN
			PID = I
			IF debug = true THEN PRINT "          CLOSING PID:"; Programs(Prognum).PID; "...";
			CloseProgram PID, 0
			IF debug = true THEN PRINT "DONE"
		END IF
		END IF
	NEXT
	IF debug = true THEN PRINT "     CLOSING ALL EXTRENUOUS FILES..."
	FOR I = 1 TO 255
	IF LEN(LCASE$(LTRIM$(RTRIM$(FilesOp$(I))))) > 0 THEN
		IF debug = true THEN PRINT "          CLOSING FILE ("; LCASE$(LTRIM$(RTRIM$(FilesOp$(I)))); ")...";
		CloseF LCASE$(LTRIM$(RTRIM$(FilesOp$(I))))
		IF debug = true THEN PRINT "DONE"
	END IF
	NEXT
	IF debug = true THEN PRINT "     ERASING ARRAYS..."
	IF debug = true THEN PRINT "          APPLET TITLE MANAGER...";
	ERASE Applets$
	IF debug = true THEN PRINT "DONE"
	IF debug = true THEN PRINT "          WINDOW MANAGER...";
	ERASE Applets$
	IF debug = true THEN PRINT "DONE"
	IF debug = true THEN PRINT "          SCRIPTING SEQUENCER...";
	ERASE Programs
	IF debug = true THEN PRINT "DONE"
	IF debug = true THEN PRINT "          FONT...";
	ERASE Fonts
	IF debug = true THEN PRINT "DONE"
	IF debug = true THEN PRINT "          ICONS...";
	ERASE ICONS$
	IF debug = true THEN PRINT "DONE"
	IF debug = true THEN PRINT "          FILE ACCESS NUMBERS...";
	ERASE FilesOp$
	IF debug = true THEN PRINT "DONE"
IF debug = true THEN PRINT
SHELL "cd \"
'PRINT "Releasing EMS."
'ReleaseEMS (StdEmsHandle)
'PRINT "EMS Heap Closed."
IF debug = true THEN PRINT "DONE"
IF debug = true THEN PRINT "M-OS Version: "; CorrKERVers$
PRINT "Done."
END
END SUB

SUB FIRSTUSE
PRINT "Have you read, and understood the license agreement that came with this program?"
PRINT
PRINT "If YES type I AgReE, Otherwise type quit"
PRINT "IF You know that your old version is compatiable with the new one, type 'upgrade'."
PRINT
INPUT "Do You Agree: ", agreement$
IF agreement$ <> "I AgReE" AND agreement$ <> "upgrade" THEN END
IF agreement$ = "upgrade" THEN
PRINT "Updating TGO! Flag File...": FirstUsePart6
EXIT SUB
END IF
CLS
COLOR 7
PRINT
PRINT "SETUP FOR TGO!"
PRINT "==============================="
PRINT
PRINT "Please Wait While I Setup Files, Directories, And Other Devices..."
PRINT
PRINT "Creating TGO! Directory...": FirstUsePart1
PRINT "Compiling tgo.ini File With Default Values...": FirstUsePart2
PRINT "Compiling data.tgo File With Root Account...": FirstUsePart3
PRINT "Creating temp.tgo File...": FirstUsePart4
PRINT "Creating mem.tgo File...": FirstUsePart5
PRINT "Compiling System Font File...": FirstUsePart7
PRINT "Creating Login Program...": FirstUsePart9
'PRINT "Compiling System File Permissions...": FirstUsePart8
PRINT "Updating TGO! Flag File...": FirstUsePart6
PRINT "INSTALLATION SUCCESSFUL... PRESS ANY KEY TO CONTINUE"
waitforinput
END SUB

SUB FirstUsePart1
	SHELL "md menu"
	SHELL "cd menu"
	SHELL "md &dapps"
	SHELL "md &ddocs"
	SHELL "cd .."
END SUB

SUB FirstUsePart2
	FileAccess$ = TGODrive$ + TGODirectory$ + "tgo.ini"
	OpenF FileAccess$, "out", 1
		OutPutTo FileAccess$, "[settings]"
		OutPutTo FileAccess$, "vers=KER699-xxx"
		OutPutTo FileAccess$, "logo=1"
		OutPutTo FileAccess$, "memr=0"
		OutPutTo FileAccess$, "data=data.tgo"
		OutPutTo FileAccess$, "temp=temp.tgo"
		OutPutTo FileAccess$, "memo=mem.tgo"
		OutPutTo FileAccess$, "[screensaver]"
		OutPutTo FileAccess$, "scre="
		OutPutTo FileAccess$, "[graphics]"
		OutPutTo FileAccess$, "grap=1"
	CloseF FileAccess$
END SUB

SUB FirstUsePart3
FileAccess$ = TGODrive$ + TGODirectory$ + "data.tgo"
OpenF FileAccess$, "out", 1
	OutPutTo FileAccess$, "*"
	OutPutTo FileAccess$, "root"
	OutPutTo FileAccess$, "1"
	OutPutTo FileAccess$, "120"
	OutPutTo FileAccess$, "1"
	DO
		LOCATE 10, 1: PRINT "ROOT PASSWORD: ": InputPassword RootPassword1$, 10, 17, 7
		LOCATE 11, 1: PRINT "ROOT PASSWORD CHECK: ": InputPassword RootPassword2$, 11, 22, 7
		IF RootPassword1$ = RootPassword2$ THEN
			PRINT
			PRINT "VERIFIED"
		ELSE
			PRINT
			PRINT "ERROR"
			LOCATE 11, 1: PRINT "                                                   "
			PRINT "                                                   "
		END IF
	LOOP UNTIL RootPassword1$ = RootPassword2$
	OutPutTo FileAccess$, RootPassword1$: RootPassword$ = ""
	OutPutTo FileAccess$, "System Administrator"
	OutPutTo FileAccess$, "KER699-xxx"
	OutPutTo FileAccess$, "0"
	OutPutTo FileAccess$, "30"
	OutPutTo FileAccess$, "30"
CloseF FileAccess$
END SUB

SUB FirstUsePart4
	FileAccess$ = TGODrive$ + TGODirectory$ + "temp.tgo"
	OpenF FileAccess$, "out", 1: CloseF FileAccess$
END SUB

SUB FirstUsePart5
	FileAccess$ = TGODrive$ + TGODirectory$ + "mem.tgo"
	OpenF FileAccess$, "out", 1: CloseF FileAccess$
END SUB

SUB FirstUsePart6
	FileAccess$ = TGODrive$ + "tgo.flg"
	OpenF FileAccess$, "out", 1
		OutPutTo FileAccess$, CorrKERVers$
		OutPutTo FileAccess$, CorrTSLVers$
		OutPutTo FileAccess$, CorrTFSVers$
		OutPutTo FileAccess$, "TGO! Flag File. Please Do Not Modify This File."
	CloseF FileAccess$
END SUB

SUB FirstUsePart7
FileAccess$ = TGODrive$ + TGODirectory$ + "system.fnt"
OpenF FileAccess$, "out", 1
FOR I = 0 TO 127
	LOCATE 1, 1: PRINT CHR$(I)
	FOR Y = 0 TO 15
		FOR x = 0 TO 7
			OutPutTo FileAccess$, LTRIM$(RTRIM$(STR$(POINT(x, Y))))
		NEXT
	NEXT
NEXT
CloseF FileAccess$
LOCATE 6, 1
END SUB

SUB FirstUsePart8
	PRINT "         PART I..."
	SHELL "dir /s /b /l > temp.fls"
	PRINT "         PART II..."
	FileAccess$ = "temp.fls"
	FreeNum = FREEFILE
	OPEN FileAccess$ FOR INPUT AS #FreeNum
		FileAccess$ = "files.dat"
		FreeNum2 = FREEFILE
		OPEN FileAccess$ FOR OUTPUT AS #FreeNum2
			x! = 0
			DO
				x! = x! + 1
				INPUT #FreeNum, NewFile$
				PRINT #FreeNum2, NewFile$ + "::root::100100000"
				LOCATE 1, 1: PRINT x!
			LOOP WHILE NOT (EOF(FreeNum))
		CLOSE #FreeNum2
	CLOSE #1
	KILL "temp.fls"
END SUB

SUB FirstUsePart9
FileAccess$ = TGODrive$ + TGODirectory$ + "login.ext"
OpenF FileAccess$, "out", 1
OutPutTo FileAccess$, "header"
OutPutTo FileAccess$, "tsl"
OutPutTo FileAccess$, CorrKERVers$
OutPutTo FileAccess$, "000"
OutPutTo FileAccess$, ""
OutPutTo FileAccess$, "awin"
OutPutTo FileAccess$, "title: Login"
OutPutTo FileAccess$, "xpos: 290"
OutPutTo FileAccess$, "ypos: 250"
OutPutTo FileAccess$, "xsize: 200"
OutPutTo FileAccess$, "ysize: 55"
OutPutTo FileAccess$, "maxx: 201"
OutPutTo FileAccess$, "maxy: 55"
OutPutTo FileAccess$, "minx: 199"
OutPutTo FileAccess$, "miny: 55"
OutPutTo FileAccess$, "stop"
OutPutTo FileAccess$, ""
OutPutTo FileAccess$, "initvar"
OutPutTo FileAccess$, "username"
OutPutTo FileAccess$, "password"
OutPutTo FileAccess$, "stop"
OutPutTo FileAccess$, ""
OutPutTo FileAccess$, "cout"
OutPutTo FileAccess$, "Username:"
OutPutTo FileAccess$, "stop"
OutPutTo FileAccess$, ""
OutPutTo FileAccess$, "input"
OutPutTo FileAccess$, "username"
OutPutTo FileAccess$, ""
OutPutTo FileAccess$, "cout"
OutPutTo FileAccess$, "/Password:"
OutPutTo FileAccess$, "stop"
OutPutTo FileAccess$, ""
OutPutTo FileAccess$, "input"
OutPutTo FileAccess$, "password"
OutPutTo FileAccess$, ""
OutPutTo FileAccess$, "cout"
OutPutTo FileAccess$, "/Please Wait..."
OutPutTo FileAccess$, "stop"
OutPutTo FileAccess$, ""
OutPutTo FileAccess$, "wait"
OutPutTo FileAccess$, "time: 1"
OutPutTo FileAccess$, "stop"
OutPutTo FileAccess$, ""
OutPutTo FileAccess$, "end"
CloseF FileAccess$
END SUB

FUNCTION FreeAppletSP
	FOR I = 1 TO UBOUND(Applets$)
		IF LTRIM$(RTRIM$(Applets$(I, 1))) = "" THEN
			FreeAppletSP = I
			EXIT FOR
		END IF
	NEXT
END FUNCTION

FUNCTION FreeIcoSP
FOR I = 0 TO UBOUND(ICONS$, 1)
	IF ICONS$(I, 1) = "" THEN
		FreeIcoSP = I
		EXIT FOR
	END IF
NEXT

END FUNCTION

FUNCTION FreeProgManSP
FOR I = 1 TO UBOUND(Applets$)
	IF Programs(I).PID = 0 AND Programs(I).CurrentLine = 0 THEN
		FreeProgManSP = I
		EXIT FOR
	END IF
NEXT
END FUNCTION

FUNCTION FreeWinManSP
FOR I = 1 TO UBOUND(windows)
	IF windows(I).TD = 0 THEN
		FreeWinManSP = I
		EXIT FUNCTION
	END IF
NEXT
END FUNCTION

'********************** GetEMS%() ********************
'*** Function returns the handle value for a block ***
'*** of EMS memory that consists of numpages% 16k  ***
'*** pages.  You _must_ keep the handle value for  ***
'*** later calls that require the handle.  Example:***
'***                                               ***
'*** EmsHandle% = GetEMS%(5)                       ***
'***                                               ***
'*** EmsHandle% holds the handle info for a block  ***
'*** of memory 5 16k pages in size, or 80k.        ***
'*****************************************************
FUNCTION GetEMS% (numpages%)

'pageoffset% = EMSPages%(0) - EMSPages%(1)

asm$ = ""
asm$ = asm$ + CHR$(85) + CHR$(137) + CHR$(229) + CHR$(139)
asm$ = asm$ + CHR$(94) + CHR$(8) + CHR$(180) + CHR$(67) + CHR$(205)
asm$ = asm$ + CHR$(103) + CHR$(139) + CHR$(94) + CHR$(6) + CHR$(137)
asm$ = asm$ + CHR$(23) + CHR$(93) + CHR$(203)

Handle% = 0
DEF SEG = VARSEG(asm$)
	 CALL Absolute(BYVAL numpages%, Handle%, SADD(asm$))
DEF SEG

'asm$ = ""
'asm$ = asm$ + CHR$(85) + CHR$(137) + CHR$(229) + CHR$(139)
'asm$ = asm$ + CHR$(86) + CHR$(8) + CHR$(139) + CHR$(126) + CHR$(6)
'asm$ = asm$ + CHR$(139) + CHR$(118) + CHR$(10) + CHR$(177) + CHR$(0)
'asm$ = asm$ + CHR$(48) + CHR$(237) + CHR$(180) + CHR$(68) + CHR$(136)
'asm$ = asm$ + CHR$(200) + CHR$(137) + CHR$(243) + CHR$(205) + CHR$(103)
'asm$ = asm$ + CHR$(70) + CHR$(65) + CHR$(57) + CHR$(254) + CHR$(117)
'asm$ = asm$ + CHR$(242) + CHR$(93) + CHR$(203)
'
'DEF SEG = VARSEG(asm$)
'   CALL Absolute(BYVAL pageoffset%, BYVAL Handle%, BYVAL numpages%, SADD(asm$))
'DEF SEG

GetEMS% = Handle%

END FUNCTION

FUNCTION GetFnum (FileName$, ErrSwitch)
	FOR I = 1 TO UBOUND(FilesOp$)
		IF LTRIM$(RTRIM$(LCASE$(FilesOp$(I)))) = LCASE$(FileName$) THEN
			GetFnum = I
			EXIT FUNCTION
		END IF
	NEXT
	IF ErrSwitch = 1 THEN
		OpenF FileName$, "out", 1
	ELSE
		OpenF FileName$, "in", 1
		GetFnum = GetFnum(FileName$, 0)
		CloseF FileAccess$
	END IF
END FUNCTION

SUB HelpScreen
PRINT "TGO! THETA TECHNOLOGIES INC."
PRINT "TGO! is (c) 1999 Steven E Wright"
PRINT "Current Version: "; CorrKERVers$
END SUB

SUB InitFiles
	FileAccess$ = TGODrive$ + "tgo.flg"
	OpenF FileAccess$, "bin", 1
		IF LOF(GetFnum(FileAccess$, 0)) = 0 THEN
			CloseF FileAccess$
			FIRSTUSE
		ELSE
			CloseF FileAccess$
			OpenF FileAccess$, "in", 1
				InputFrom FileAccess$, KERVersion$, 0
				IF EOF(GetFnum(FileAccess$, 0)) THEN GOTO skipit
				InputFrom FileAccess$, TSLVersion$, 0
				IF EOF(GetFnum(FileAccess$, 0)) THEN GOTO skipit
				InputFrom FileAccess$, TFSVersion$, 0
skipit:
				conditiona = (LCASE$(KERVersion$) <> LCASE$(CorrKERVers$))
				conditionb = (LCASE$(TSLVersion$) <> LCASE$(CorrTSLVers$))
				ConditionC = (LCASE$(TFSVersion$) <> LCASE$(CorrTFSVers$))
				ConditionF = conditiona OR conditionb OR ConditionC
				IF ConditionF THEN
					CloseF FileAccess$
					KILL FileAccess$
					InitFiles
					OpenF FileAccess$, "in", 1
		END IF
			CloseF FileAccess$
		END IF
	
	FileAccess$ = TGODrive$ + TGODirectory$ + "tgo.ini"
	OpenF FileAccess$, "in", 0
				 
		DO
			InputFrom FileAccess$, A$, 1
			IF EOF(GetFnum(FileAccess$, 0)) THEN END
		LOOP UNTIL A$ = "[settings]" OR EOF(GetFnum(FileAccess$, 0))

		InputFrom FileAccess$, VersionFull$, 1
		Version$ = RIGHT$(VersionFull$, LEN(VersionFull$) - 5)

		InputFrom FileAccess$, RunLogo$, 1
		RunLogo = VAL(RIGHT$(RunLogo$, LEN(RunLogo$) - 5))

		InputFrom FileAccess$, RunMem$, 1
		RunMem = VAL(RIGHT$(RunMem$, LEN(RunMem$) - 5))

		InputFrom FileAccess$, Datafile$, 1
		Datafile$ = (RIGHT$(Datafile$, LEN(Datafile$) - 5))

		InputFrom FileAccess$, TempFile$, 1
		TempFile$ = (RIGHT$(TempFile$, LEN(TempFile$) - 5))

		InputFrom FileAccess$, MemAddyFile$, 1
		MemAddyFile$ = (RIGHT$(MemAddyFile$, LEN(MemAddyFile$) - 5))

		InputFrom FileAccess$, A$, 1
				 
		InputFrom FileAccess$, ScreenSaverFile$, 1
		ScreenSaverFile$ = (RIGHT$(ScreenSaverFile$, LEN(ScreenSaverFile$) - 5))
		
		InputFrom FileAccess$, A$, 0

		InputFrom FileAccess$, grad$, 1
		grad = VAL(RIGHT$(grad$, LEN(grad$) - 5))

	CloseF FileAccess$
	FileAccess$ = ""
END SUB

SUB InitFont
FileAccess$ = TGODrive$ + TGODirectory$ + "system.fnt"
OpenF FileAccess$, "in", 0
	FOR charactor = 0 TO 127
		FOR Y = 1 TO 16
			FOR x = 1 TO 8
					InputFrom FileAccess$, Temp$, 0
					Fonts(charactor, x, Y) = VAL(Temp$)
			NEXT
		NEXT
	NEXT
CloseF FileAccess$
END SUB

SUB InitIcons

SHELL "path = %PATH%;" + TGODrive$ + TGODirectory$
SHELL "dir /b /l > icons.dat"

FileAccess$ = "icons.dat"
OpenF FileAccess$, "in", 0
	DO
	IF EOF(GetFnum(FileAccess$, 0)) THEN EXIT DO
		InputFrom FileAccess$, IcoData$, 0
	IcoData$ = LCASE$(LTRIM$(RTRIM$(IcoData$)))

	IF RIGHT$(IcoData$, 3) = "lnk" THEN
		Space = FreeIcoSP
		ICONS$(Space, 0) = IcoData$
		file2Access$ = TGODrive$ + TGODirectory$ + ICONS$(FreeIcoSP, 0)
		OpenF file2Access$, "in", 0
			InputFrom file2Access$, ICONS$(Space, 1), 0
			InputFrom file2Access$, ICONS$(Space, 2), 0
			InputFrom file2Access$, ICONS$(Space, 3), 0
		CloseF file2Access$
	END IF
	LOOP WHILE NOT (EOF(GetFnum(FileAccess$, 0)))
CloseF FileAccess$
KILL "icons.dat"

END SUB

SUB InitMouse
	DEF SEG = VARSEG(asm(0))
	POKE VARPTR(asm(0)) + 0, &HB8
	POKE VARPTR(asm(0)) + 1, &H0
	POKE VARPTR(asm(0)) + 2, &H0
	POKE VARPTR(asm(0)) + 3, &H55
	POKE VARPTR(asm(0)) + 4, &H8B
	POKE VARPTR(asm(0)) + 5, &HEC
	POKE VARPTR(asm(0)) + 6, &HCD
	POKE VARPTR(asm(0)) + 7, &H33
	POKE VARPTR(asm(0)) + 8, &H92
	POKE VARPTR(asm(0)) + 9, &H8B
	POKE VARPTR(asm(0)) + 10, &H5E
	POKE VARPTR(asm(0)) + 11, &H6
	POKE VARPTR(asm(0)) + 12, &H89
	POKE VARPTR(asm(0)) + 13, &H7
	POKE VARPTR(asm(0)) + 14, &H5D
	POKE VARPTR(asm(0)) + 15, &HCA
	POKE VARPTR(asm(0)) + 16, &H2
	POKE VARPTR(asm(0)) + 17, &H0
END SUB

SUB InitPalette
	BlueBG = 30
	RedBG = 15
	GreenBG = 15
	PALETTE 0, 65536 * BlueBG + 256 * GreenBG + RedBG
	PALETTE 2, 65536 * 15 + 256 * 30
	PALETTE 4, 65536 * 5 + 256 * 10 + 40
	PALETTE 3, 65536 * 60 + 256 * 60 + 60
	PALETTE 9, 65536 * 0 + 256 * 0 + 0
	PALETTE 10, 65536 * INT(63 / 2.25) + 256 * INT(63 / 2.25) + INT(63 / 2.25)
	IF grad = 1 THEN PALETTE 10, 65536 * INT(BlueBG / 2.25) + 256 * INT(GreenBG / 2.25) + INT(RedBG / 2.25)
	PALETTE 11, 65536 * INT(63 / 1.75) + 256 * INT(63 / 1.75) + INT(63 / 1.75)
	IF grad = 1 THEN PALETTE 11, 65536 * INT(BlueBG / 1.75) + 256 * INT(GreenBG / 1.75) + INT(RedBG / 1.75)
	PALETTE 12, 65536 * INT(63 / 1.25) + 256 * INT(63 / 1.25) + INT(63 / 1.25)
	IF grad = 1 THEN PALETTE 12, 65536 * INT(BlueBG / 1.25) + 256 * INT(GreenBG / 1.25) + INT(RedBG / 1.25)
	PALETTE 15, 65536 * 45 + 256 * 45 + 45
END SUB

SUB initscreen (ScreenNum)
	SCREEN ScreenNum
	SELECT CASE ScreenNum
		CASE 12
			ScreenX = 640
			ScreenY = 480
		CASE ELSE
			ERROR 106
	END SELECT
END SUB

SUB InitWin (PID)
'Add Types Of Windows
			CW = FreeWinManSP
			windows(CW).PrintLine = 0
			windows(CW).SizX = 100
			windows(CW).SizY = 100
			windows(CW).PosX = 100
			windows(CW).PosY = 100
			windows(CW).PID = PID
			windows(CW).TD = 1
			windows(CW).MinX = 40
			windows(CW).MinY = 20
			windows(CW).MaxX = 640
			windows(CW).MaxY = 480
			windows(CW).OutF = TGODrive$ + TGODirectory$ + LTRIM$(RTRIM$(STR$(PID))) + ".tou"
END SUB

SUB InputFrom (FileName$, Variable$, Mode)
	FiNum = GetFnum(FileName$, 1)
	IF EOF(FiNum) THEN
		Variable$ = ""
		EXIT SUB
	ELSE
		SELECT CASE Mode
		CASE 0
			INPUT #FiNum, Variable$
		CASE 1
			LINE INPUT #FiNum, Variable$
		CASE ELSE
			ERROR 109
		END SELECT
	END IF
END SUB

SUB InputPassword (Password$, lineo, colo, colors)
	COLOR colors
	Password$ = ""
	APasswordCharactor$ = ""
	LOCATE lineo, colo
	DO WHILE NOT APasswordCharactor$ = CHR$(13)
		Password$ = Password$ + APasswordCharactor$
		LINE ((colo * 8) + ((LEN(Password$) + 1) * 8) - 16, lineo * 16 - 16)-((colo * 8) + ((LEN(Password$) + 1) * 8) - 8, lineo * 16), colors, BF
		DO
			APasswordCharactor$ = INKEY$
		LOOP WHILE APasswordCharactor$ = ""
			LINE ((colo * 8) + ((LEN(Password$) + 1) * 8) - 16, lineo * 16 - 16)-((colo * 8) + ((LEN(Password$) + 1) * 8) - 8, lineo * 16), 0, BF
		IF APasswordCharactor$ = "" THEN
			APasswordCharactor$ = ""
			IF LEN(Password$) > 0 THEN
				Password$ = LEFT$(Password$, LEN(Password$) - 1)
				LOCATE lineo, colo, 1, 0, 7
				FOR j = 1 TO LEN(Password$) + 1
					COLOR 0
					PRINT "*";
				NEXT
				COLOR colors
				LOCATE lineo, colo, 1, 0, 7
				FOR j = 1 TO LEN(Password$)
					PRINT "*";
				NEXT
			ELSE
				BEEP
			END IF
		ELSE
			IF APasswordCharactor$ <> CHR$(13) THEN PRINT "*";
		END IF
	LOOP

	Encrypt Password$
END SUB

SUB Interface
DO
	IF sysrunlevel <> 0 THEN EXIT SUB
	Choice$ = INKEY$
	RunApps
	RunMenu
	CheckMouseFirst
	CheckMouseSecond
LOOP
END SUB

SUB KillPID
INPUT "PID TO KILL: ", PID
CloseProgram PID, 0
END SUB

SUB Login
DO
	Username$ = ""
	Password$ = ""
	ErrorAtStartUp = 0
	execprog "login.ext", 1, 1
	RunApps
	DO
		IF sysrunlevel <> 0 THEN EXIT SUB
		Choice$ = INKEY$
		RunApps
		CheckMouseFirst
	LOOP UNTIL Programs(1).CurrentLine = 1
LOOP UNTIL ErrorAtStartUp = 0
loggedin = 1
END SUB

'***************** MapEMS () ***********************************
'*** Sets the page of a memory block (identified by Handle%) ***
'*** that is located at the beginning of the page frame.     ***
'*** Example:                                                ***
'***                                                         ***
'*** EmsHandle% = GetEMS%(8)                                 ***
'*** MapEMS EmsHandle%, 4                                    ***
'***                                                         ***
'*** When the page frame segment is next written to, the info***
'*** will be placed starting at the 4th page in the block of ***
'*** memory represented by EmsHandle%.  This could be use,   ***
'*** for instance, to store multiple SCREEN 13 images in one ***
'*** EMS block, by moving the first 64k image into the first ***
'*** 4 16k pages (16000 * 4 = 64000) by using:               ***
'***                                                         ***
'*** MapEMS EmsHandle%, 0                                    ***
'***                                                         ***
'*** And then putting the next 64k image into the next 4 EMS ***
'*** pages by using:                                         ***
'***                                                         ***
'*** MapEMS EmsHandle%, 4                                    ***
'***                                                         ***
'*** ... and then moving the image into the memory block.    ***
'***************************************************************
SUB MapEMS (Handle%, pageoffset%)

numpages% = 4

asm$ = ""
asm$ = asm$ + CHR$(85) + CHR$(137) + CHR$(229) + CHR$(139)
asm$ = asm$ + CHR$(86) + CHR$(8) + CHR$(139) + CHR$(126) + CHR$(6)
asm$ = asm$ + CHR$(139) + CHR$(118) + CHR$(10) + CHR$(177) + CHR$(0)
asm$ = asm$ + CHR$(48) + CHR$(237) + CHR$(180) + CHR$(68) + CHR$(136)
asm$ = asm$ + CHR$(200) + CHR$(137) + CHR$(243) + CHR$(205) + CHR$(103)
asm$ = asm$ + CHR$(70) + CHR$(65) + CHR$(57) + CHR$(249) + CHR$(117)
asm$ = asm$ + CHR$(242) + CHR$(93) + CHR$(203)

DEF SEG = VARSEG(asm$)
	 CALL Absolute(BYVAL pageoffset%, BYVAL Handle%, BYVAL numpages%, SADD(asm$))
DEF SEG

END SUB

SUB MaxWindow (PID)
	x = WinWithPID(PID)
	IF x = 0 THEN EXIT SUB
	windows(x).maxed = 1
	windows(x).mined = 0
	windows(x).TD = .5
	RefWindows 1, -1
END SUB

SUB MaxWindowManual (PID)
	winnum = WinWithPID(PID)
	IF windows(winnum).maxed = 0 THEN
		IF CurrentX < windows(winnum).PosX + windows(winnum).SizX - 13 AND CurrentX > windows(winnum).PosX + windows(winnum).SizX - 26 THEN
			IF CurrentY > windows(winnum).PosY AND CurrentY < windows(winnum).PosY + 13 THEN
				MaxWindow PID
			END IF
		END IF
	ELSE
		IF CurrentX < 640 - 13 AND CurrentX > 640 - 26 THEN
			IF CurrentY > 0 AND CurrentY < 13 THEN
				UnMaxWindow PID
			END IF
		END IF
	END IF
END SUB

'******************************* MemCopy() ***********************
'*** Copies the number of bytes specified in 'bytes' from the  ***
'*** memory location fromseg:fromoff to the memory location    ***
'*** toseg:tooff.  To copy more than 32,767 bytes (max. of     ***
'*** 65,536 bytes) put the 'bytes' value in HEX form.          ***
'*****************************************************************
SUB MemCopy (fromseg, fromoff, toseg, tooff, bytes)

asm$ = ""
asm$ = asm$ + CHR$(85) + CHR$(137) + CHR$(229) + CHR$(30)
asm$ = asm$ + CHR$(139) + CHR$(70) + CHR$(10) + CHR$(142) + CHR$(192)
asm$ = asm$ + CHR$(139) + CHR$(70) + CHR$(14) + CHR$(142) + CHR$(216)
asm$ = asm$ + CHR$(139) + CHR$(118) + CHR$(8) + CHR$(139) + CHR$(126)
asm$ = asm$ + CHR$(12) + CHR$(139) + CHR$(78) + CHR$(6) + CHR$(243)
asm$ = asm$ + CHR$(164) + CHR$(31) + CHR$(93) + CHR$(203)

DEF SEG = VARSEG(asm$)
	 CALL Absolute(BYVAL fromseg, BYVAL fromoff, BYVAL toseg, BYVAL tooff, BYVAL bytes, SADD(asm$))
DEF SEG


END SUB

SUB MinWindow (PID)
	winnum = WinWithPID(PID)
	IF winnum = 0 THEN EXIT SUB
	windows(winnum).mined = 1
	windows(winnum).maxed = 0
	windows(winnum).TD = .5
	RefWindows 1, -1
END SUB

SUB MinWindowManual (PID)
	winnum = WinWithPID(PID)
	IF CurrentX < windows(winnum).PosX + windows(winnum).SizX - 26 AND CurrentX > windows(winnum).PosX + windows(winnum).SizX - 39 THEN
		IF CurrentY > windows(winnum).PosY AND CurrentY < windows(winnum).PosY + 13 THEN
			IF windows(winnum).mined = 0 THEN
				MinWindow PID
			ELSE
				UnMinWindow PID
			END IF
		END IF
	END IF
END SUB

SUB mouse (CX, DX, BX)
	MousePointer 3
	DEF SEG = VARSEG(asm(0))          'Get array segment (nnnn:
	POKE VARPTR(asm(4)), &H92           'Swap code,Get CX setup
	CALL Absolute(CX, VARPTR(asm(0)))     'Run Code
	CX = CX '/ 8                     'Adjust 25x80
	POKE VARPTR(asm(4)), &H91           'Swap code,Get DX setup
	CALL Absolute(DX, VARPTR(asm(0)))     'Run Code
	DX = DX '/ 8                     'Adjust 25x80
	POKE VARPTR(asm(4)), &H93           'Swap code,Get BX setup
	CALL Absolute(BX, VARPTR(asm(0)))     'Run Code

END SUB

FUNCTION MouseOnIcon
	FOR I = 1 TO FreeIcoSP - 1
		FreeFileNum = FREEFILE
		FileAccess$ = ICONS$(I, 1)
		OPEN FileAccess$ FOR INPUT AS #FreeFileNum
			INPUT #FreeFileNum, Scrap$
			INPUT #FreeFileNum, x
			INPUT #FreeFileNum, Y
			IF CurrentX >= x AND CurrentX <= x + 20 THEN
				IF CurrentY >= Y AND CurrentY <= Y + 20 THEN
					MouseOnIcon = I
					EXIT FOR
				END IF
			END IF
		CLOSE #FreeFileNum
	NEXT
END FUNCTION

SUB MousePointer (SW)
	'Note: SW = 0-reset 1-on 2-off 3-coordinates
	DEF SEG = VARSEG(asm(0))
	POKE VARPTR(asm(0)) + 1, SW
	CALL Absolute(c, VARPTR(asm(0)))
END SUB

FUNCTION MousePressed
	mouse CX, DX, BX
	IF BX > 0 THEN MousePressed = 1
END FUNCTION

SUB MoveIcon (ico)
IF ICONS$(ico, 0) > "" THEN
XiPosition = VAL(ICONS$(ico, 2))
YiPosition = VAL(ICONS$(ico, 3))
XSIZE = 20
YSize = 20
OffsetX = CurrentX - XiPosition
OffsetY = CurrentY - YiPosition

IF CurrentX > XiPosition AND CurrentX < XiPosition + XSIZE THEN
	IF CurrentY > YiPosition AND CurrentY < YiPosition + YSize THEN
		CLS
		CursorOff
	DO
		ICONS$(ico, 2) = STR$(CurrentX - OffsetX)
		ICONS$(ico, 3) = STR$(CurrentY - OffsetY)
		IF VAL(ICONS$(ico, 2)) < 1 THEN ICONS$(ico, 2) = "1"
		IF VAL(ICONS$(ico, 2)) + XSIZE > 640 THEN ICONS$(ico, 2) = STR$(640 - XSIZE)
		IF VAL(ICONS$(ico, 3)) < 1 THEN ICONS$(ico, 3) = "1"
		IF VAL(ICONS$(ico, 3)) + YSize > 410 THEN ICONS$(ico, 3) = STR$(409 - YSize)
				
		IF CurrentX <> PXMouse THEN
			LINE (LXiPosition, LYiPosition)-(LXiPosition + XSIZE, LYiPosition + YSize), 0, B
			LINE (VAL(ICONS$(ico, 2)), VAL(ICONS$(ico, 3)))-(VAL(ICONS$(ico, 2)) + XSIZE, VAL(ICONS$(ico, 3)) + YSize), 9, B
			LXiPosition = VAL(ICONS$(ico, 2))
			LYiPosition = VAL(ICONS$(ico, 3))
			PXMouse = CurrentX
		END IF

		IF CurrentY <> PYMouse THEN
			LINE (LXiPosition, LYiPosition)-(LXiPosition + XSIZE, LYiPosition + YSize), 0, B
			LINE (VAL(ICONS$(ico, 2)), VAL(ICONS$(ico, 3)))-(VAL(ICONS$(ico, 2)) + XSIZE, VAL(ICONS$(ico, 3)) + YSize), 9, B
			LXiPosition = VAL(ICONS$(ico, 2))
			LYiPosition = VAL(ICONS$(ico, 3))
			PYMouse = CurrentY
		END IF
		 mouse CX, DX, BX
	LOOP UNTIL MousePressed = 0

	PYMouse = 0
	PXMouse = 0
	RefIcoFile (ico)
	RefWindows 1, -1
	cursorON
			 
	END IF
END IF
END IF
END SUB

SUB MoveWindow (PID)

winnum = WinWithPID(PID)

IF windows(winnum).maxed = false THEN
					 
XSIZE = windows(winnum).SizX
YSize = windows(winnum).SizY
XPosition = windows(winnum).PosX
YPosition = windows(winnum).PosY
TD = windows(winnum).TD
PXPosition = CurrentX
PYPosition = CurrentX
DistanceX = CurrentX - XPosition
DistanceY = CurrentY - YPosition
mined = windows(winnum).mined

IF mined = 1 THEN
	YSize = 16
END IF


IF CurrentX > XPosition + 2 AND CurrentX < XPosition + XSIZE THEN
	IF CurrentY > YPosition AND CurrentY < YPosition + 16 THEN
		IF TD < UBOUND(Applets$) AND TD > 0 THEN
			windows(winnum).TD = .5
			IF winnum = 0 THEN EXIT SUB
				
		CLS
		CursorOff
				 
		DO
		windows(winnum).PosX = CurrentX - DistanceX
		windows(winnum).PosY = CurrentY - DistanceY
		IF windows(winnum).PosX < 1 THEN windows(winnum).PosX = 1
		IF windows(winnum).PosX + XSIZE > 640 THEN windows(winnum).PosX = 640 - XSIZE
		IF windows(winnum).PosY < 1 THEN windows(winnum).PosY = 1
		IF windows(winnum).PosY + YSize > 480 THEN windows(winnum).PosY = 479 - YSize
				
		IF CurrentX <> PXMouse THEN
			LINE (LXPosition, LYPosition)-(LXPosition + XSIZE, LYPosition + YSize), 0, B
			LINE (windows(winnum).PosX, windows(winnum).PosY)-(windows(winnum).PosX + XSIZE, windows(winnum).PosY + YSize), 9, B
			LXPosition = windows(winnum).PosX
			LYPosition = windows(winnum).PosY
			PXMouse = CurrentX
		END IF

		IF CurrentY <> PYMouse THEN
			LINE (LXPosition, LYPosition)-(LXPosition + XSIZE, LYPosition + YSize), 0, B
			LINE (windows(winnum).PosX, windows(winnum).PosY)-(windows(winnum).PosX + XSIZE, windows(winnum).PosY + YSize), 9, B
			LXPosition = windows(winnum).PosX
			LYPosition = windows(winnum).PosY
			PYMouse = CurrentY
		END IF
		mouse CX, DX, BX
	LOOP UNTIL MousePressed = 0

	PYMouse = 0
	PXMouse = 0
			END IF
			
	RefWindows 1, -1
	cursorON
				
		END IF
	END IF
END IF


END SUB

SUB NewVar (PID, Name$, type$, value$)
FOR I = 1 TO UBOUND(Variables$, 2)
	IF Variables$(PID, I) = "" THEN
		NewSpace = I
		EXIT FOR
	END IF
NEXT
Variables$(PID, NewSpace) = Name$ + "||" + type$ + "||" + value$
END SUB

SUB OpenF (FileAccess$, AccessType$, IgnoreNew)
'FilePerms: FileName$::Owner$::rxwrxwrxw (Root, Owner, Global)

IF CheckOpen(FileAccess$) THEN
NewNum = FREEFILE
OPEN FileAccess$ FOR BINARY AS #NewNum
IF LOF(NewNum) = 0 THEN
	IF IgnoreNew = false THEN
		CLOSE #NewNum                   'Close It
		KILL FileAccess$                'Delete It
		ErrorNu 114, "OPENF/FILE NOT FOUND!" 'Print Error: File Not Found
	ELSE
		CLOSE #NewNum
		OPEN FileAccess$ FOR OUTPUT AS #NewNum
		CLOSE #NewNum
		GOTO LineRef
	END IF
ELSE
		CLOSE #NewNum                     'Else Close it, as if Nothing Happened
LineRef:
		FilesOp$(NewNum) = FileAccess$     'Enter File Registry
		SELECT CASE LCASE$(AccessType$)
			CASE "in"
				OPEN FileAccess$ FOR INPUT LOCK READ WRITE AS #NewNum
			CASE "out"
				OPEN FileAccess$ FOR OUTPUT LOCK READ WRITE AS #NewNum
			CASE "bin"
				OPEN FileAccess$ FOR BINARY LOCK READ WRITE AS #NewNum
			CASE "ran"
				OPEN FileAccess$ FOR RANDOM LOCK READ WRITE AS #NewNum
			CASE "app"
				OPEN FileAccess$ FOR APPEND LOCK READ WRITE AS #NewNum
		END SELECT
END IF
END IF
END SUB

SUB OutPutTo (FileName$, Text$)

IF NOT (CheckOpen(FileName$)) THEN
	PRINT #GetFnum(FileName$, 0), Text$
END IF

END SUB

DEFSNG A-Z
'******************************* PageFrame% ***************************
'*** Returns the segment that you will need to write to in order to ***
'*** store your data into EMS memory.  For example, PageFrame% may  ***
'*** return D000 (HEX, -12288 decimal), and then you might do this: ***
'***                                                                ***
'*** DEF SEG = PageFrame%        'D000                              ***
'*** MyData$ = "This is a block of data I want to store in EMS."    ***
'*** FOR X = 1 TO LEN(MyData$)                                      ***
'***   POKE X, ASC(MID$(MyData$, X, 1))                             ***
'*** NEXT X                                                         ***
'*** DEF SEG                                                        ***
'***                                                                ***
'*** Note, though, that you have to have a block of EMS opened with ***
'*** GetEMS%() and maped with MapEMS before you can write to the    ***
'*** block.                                                         ***
'**********************************************************************
FUNCTION PageFrame%

asm$ = ""
asm$ = asm$ + CHR$(85) + CHR$(137) + CHR$(229) + CHR$(180)
asm$ = asm$ + CHR$(65) + CHR$(205) + CHR$(103) + CHR$(139) + CHR$(126)
asm$ = asm$ + CHR$(6) + CHR$(137) + CHR$(29) + CHR$(93) + CHR$(203)

PageFrameAddr% = 0
DEF SEG = VARSEG(asm$)
	 CALL Absolute(PageFrameAddr%, SADD(asm$))
DEF SEG

PageFrame% = PageFrameAddr%

END FUNCTION

DEFINT A-Z
SUB PrintButtons (XPositionB, YPositionB, XSizeB)
	FOR ButtonNumber = 0 TO 2
		FOR x = 1 TO 13
			FOR Y = 1 TO 13
				READ pointval
				IF NOT (pointval = 2) THEN
				xPoint = XPositionB + XSizeB - Y - (12 * ButtonNumber) - 1
				yPoint = YPositionB + x + 1
				PSET (xPoint, yPoint), pointval
				END IF
			NEXT
		NEXT
	NEXT
	RESTORE
END SUB

SUB PrintToWin (PID, Text$)

winnum = WinWithPID(PID)
IF winnum < UBOUND(windows) AND winnum > 0 THEN
FileAccess$ = RTRIM$(windows(winnum).OutF)

OpenF FileAccess$, "app", 1
	OutPutTo FileAccess$, Text$
CloseF FileAccess$

RefWindows 1, winnum
END IF

END SUB

FUNCTION ProgManWithPid (PID)
	FOR I = 1 TO UBOUND(Programs)
		IF Programs(I).PID = PID THEN
			ProgManWithPid = I
			EXIT FUNCTION
		END IF
	NEXT
END FUNCTION

SUB Quitter
	END
END SUB

SUB RefIcoFile (ico)
	FileAccess$ = "temp.tgo"
	OpenF FileAccess$, "out", 1
		file2Access$ = ICONS$(ico, 0)
		OpenF file2Access$, "in", 0
			OutPutTo FileAccess$, ICONS$(ico, 1)
			OutPutTo FileAccess$, ICONS$(ico, 2)
			OutPutTo FileAccess$, ICONS$(ico, 3)
			InputFrom file2Access$, Scrap$, 0
			InputFrom file2Access$, Scrap$, 0
			InputFrom file2Access$, Scrap$, 0
			DO
				IF EOF(GetFnum(file2Access$, 0)) THEN EXIT DO
				InputFrom file2Access$, NewData$, 0
				OutPutTo FileAccess$, NewData$
			LOOP WHILE NOT (EOF(GetFnum(file2Access$, 0)))
		CloseF file2Access$
	CloseF FileAccess$
	OpenF FileAccess$, "in", 0
		OpenF file2Access$, "out", 0
			DO
				IF EOF(GetFnum(FileAccess$, 0)) THEN EXIT DO
				InputFrom FileAccess$, NewData$, 1
				OutPutTo file2Access$, NewData$
			LOOP WHILE NOT (EOF(GetFnum(FileAccess$, 0)))
		CloseF file2Access$
	CloseF FileAccess$
END SUB

SUB RefIcons

num = 0

DO
IF ICONS$(num, 0) = "" THEN EXIT DO

FileAccess$ = TGODrive$ + TGODirectory$ + ICONS$(num, 0)
OpenF FileAccess$, "in", 0
InputFrom FileAccess$, Temp$, 0
InputFrom FileAccess$, StartX$, 0
InputFrom FileAccess$, StartY$, 0
StartX = VAL(StartX$)
StartY = VAL(StartY$)

FOR Y = 1 TO 20
	FOR x = 1 TO 20
		IF EOF(GetFnum(FileAccess$, 0)) THEN EXIT FOR
		InputFrom FileAccess$, colo$, 1
		PSET (x + StartX, Y + StartY), VAL(colo$)
	NEXT
NEXT
CloseF FileAccess$
num = num + 1
LOOP

END SUB

SUB RefWindows (BG, win)
WindowsSort
CursorOff
IF win > -1 THEN GOTO refspecific
CLS
IF loggedin = 1 THEN
IF StartActive = 1 THEN
	LINE (50, 465)-(0, 480), 8, BF
	CurCol = 11
ELSE
	LINE (50, 465)-(0, 480), 11, BF
	CurCol = 9
END IF
LINE (50, 465)-(0, 480), 9, B
LINE (49, 466)-(1, 479), 10, B

LINE (50, 468)-(640, 480), 11, BF
LINE (0, 467)-(640, 467), 10
LINE (0, 466)-(640, 466), 8
LINE (0, 465)-(640, 465), 9

cout "Start", -6, 466, CurCol
'cout "Name: " + RealName$ + "     User Name: " + UserName$ + "     Kernel: " + CorrKERVers$, 60, 466, 9

IF BG = 1 THEN RefIcons
END IF
refspecific:
IF win > -1 THEN
startit = win
endit = win
ELSE
startit = UBOUND(windows)
endit = 1
END IF

FOR x = startit TO endit STEP -1
			 IF windows(x).TD > 0 THEN

		TD = windows(x).TD
		XSIZE = windows(x).SizX
		YSize = windows(x).SizY
		XPosition = windows(x).PosX
		YPosition = windows(x).PosY
		maxed = windows(x).maxed
		mined = windows(x).mined
		PID = windows(x).PID

		IF mined = 1 THEN
		YSize = 16
		END IF
				 
		IF maxed = 1 THEN
		XSIZE = 640
		YSize = 470
		XPosition = 0
		YPosition = 0
		END IF

		LINE (XPosition, YPosition)-(XPosition + XSIZE, YPosition + YSize), 0, BF
		LINE (XPosition - I, YPosition - I)-(XPosition + I + XSIZE, YPosition + I + YSize), 9, B
		LINE (XPosition, YPosition + 16 + I)-(XPosition + XSIZE, YPosition + 16 + I), 9
				 
		IF TD > 1 THEN PAINT (XPosition + 4, YPosition + 4), 2, 9
		IF TD = 1 THEN PAINT (XPosition + 4, YPosition + 4), 6, 9
		IF (windows(x).mined = 1) = false THEN
			PAINT (XPosition + 4, YPosition + 25), 3, 9
		END IF
				 
		LINE (XPosition - 1, YPosition - 1)-(XPosition + 1 + XSIZE, YPosition - 1), 11
		LINE (XPosition - 2, YPosition - 2)-(XPosition + 2 + XSIZE, YPosition - 2), 12
		LINE (XPosition - 1, YPosition - 1)-(XPosition - 1, YPosition + 1 + YSize), 11
		LINE (XPosition - 2, YPosition - 2)-(XPosition - 2, YPosition + 2 + YSize), 12
				 
		LINE (XPosition + 1 + XSIZE, YPosition + 1 + YSize)-(XPosition + 1 + XSIZE, YPosition - 1), 10
		LINE (XPosition + 2 + XSIZE, YPosition + 2 + YSize)-(XPosition + 2 + XSIZE, YPosition - 2), 11
		LINE (XPosition + 1 + XSIZE, YPosition + 1 + YSize)-(XPosition - 1, YPosition + 1 + YSize), 10
		LINE (XPosition + 2 + XSIZE, YPosition + 2 + YSize)-(XPosition - 2, YPosition + 2 + YSize), 11
		
		IF grad = 1 THEN
			FOR X1 = XPosition TO XPosition + XSIZE
				PercentOver = 100 - (((X1 - XPosition) / XSIZE) * 100)
				PointsPerPixel = (PercentOver / 50) * 15
				IF PointsPerPixel < 1 THEN PointsPerPixel = 1
				FOR Y1 = YPosition TO YPosition + 15 STEP PointsPerPixel
							ypos = YPosition + 7 + (7 - (RND * 14))
							PSET (X1, ypos), 2
				NEXT Y1
			NEXT X1
		END IF


'PRINT CONTENT...
j = 0
Y = 0
jk = 0
IF (windows(x).mined = 1) = false THEN
winnum = x
FileAccess$ = RTRIM$(windows(winnum).OutF)
LineOn = windows(winnum).PrintLine
OpenF FileAccess$, "in", 1
	IF LineOn > 0 THEN
	DO
		IF EOF(GetFnum(FileAccess$, 0)) THEN
			IF LineOn > 0 THEN
				windows(winnum).PrintLine = windows(winnum).PrintLine - 1
			END IF
			EXIT FOR
		END IF
		InputFrom FileAccess$, Scrap$, 0
		FOR t = 1 TO LEN(Scrap$)
			IF MID$(Scrap$, t, 1) = "/" THEN ClineOn = ClineOn + 1
		NEXT
	LOOP UNTIL LineOn - 2 = ClineOn
	END IF
	TotalLines = (YSize - 32) / 16
	TotalWidth = (XSIZE) / 8
	jk = 1
	j = 0
	DO
		IF EOF(GetFnum(FileAccess$, 0)) THEN GOTO ExitThis
		InputFrom FileAccess$, NewLine$, 1
		FOR u = 0 TO LEN(NewLine$)
			IF u > 0 THEN j = j + 1
			IF MID$(NewLine$, u + 1, 1) = "/" THEN
				Y = Y + 1
				j = -1
			END IF
			CXPosition = (XPosition) + ((j) * 8) - 5
			CYPosition = YPosition + 19 + (16 * Y)
			IF NOT (CXPosition > (XPosition + XSIZE - 16)) THEN
				cout MID$(NewLine$, u + 1, 1), CXPosition, CYPosition, 9
			END IF
		NEXT
	LOOP UNTIL Y = TotalLines
ExitThis:
CloseF FileAccess$
END IF

'FINISHED... PRINT TITLE
IF LEN(Applets$(PID, 1)) > (XSIZE) / 8 THEN
	Title$ = LEFT$(Applets$(PID, 1), LEN(Applets$(PID, 1)) - (LEN(Applets$(PID, 1)) - (XSIZE - 16) / 8))
ELSE
	Title$ = Applets$(PID, 1)
END IF
cout Title$, XPosition + 2, YPosition + 2, 9
PrintButtons XPosition, YPosition, XSIZE
	END IF
NEXT

'Start Menu
IF StartActive = 1 THEN
	FOR o = 1 TO UBOUND(Startmenu$, 2)
		IF Startmenu$(2, o) = "" THEN EXIT FOR
		IF LEFT$(Startmenu$(2, o), 2) = "&d" THEN
			cout RIGHT$(Startmenu$(2, o), LEN(Startmenu$(2, o)) - 2), 10, 460 - (17 * o), 2
		ELSE
			cout LEFT$(Startmenu$(2, o), LEN(Startmenu$(2, o)) - 4), 10, 460 - (17 * o), 9
		END IF
	NEXT
	LINE (10, 460)-(110, 460 - (17 * (o - 1))), 9, B
	LINE (10, 460)-(0, 460 - (17 * (o - 1))), 9, BF
	LINE (9, 459)-(1, 461 - (17 * (o - 1))), 1, BF
	IF o >= 4 THEN
	cout "O", -8, 445, 9
	cout "G", -8, 430, 9
	cout "T", -8, 415, 9
	END IF
END IF
cursorON
END SUB

SUB RotatePalette (BeginColour%, EndColour%)

IF BeginColour% > EndColour% THEN
	Cstep% = -1
ELSEIF BeginColour% < EndColour% THEN
	Cstep% = 1
ELSE
	EXIT SUB
END IF
OUT &H3C7, EndColour%
RedSave% = INP(&H3C9)
GreenSave% = INP(&H3C9)
BlueSave% = INP(&H3C9)
FOR I% = BeginColour% TO EndColour% STEP Cstep%
	OUT &H3C7, I%
	Red% = INP(&H3C9)
	Green% = INP(&H3C9)
	Blue% = INP(&H3C9)
	OUT &H3C8, I%
	OUT &H3C9, RedSave%
	OUT &H3C9, GreenSave%
	OUT &H3C9, BlueSave%
	RedSave% = Red%
	GreenSave% = Green%
	BlueSave% = Blue%
NEXT I%

END SUB

SUB RunApps
FOR I = 1 TO UBOUND(Applets$)
	IF LTRIM$(RTRIM$(Applets$(I, 0))) > "" THEN
		Scripter I
	END IF
NEXT
END SUB

SUB RunMenu
I = 0
IF StartActive = 1 THEN
	DO
	I = I + 1
	IF I = 20 OR Startmenu$(1, I) = "" THEN EXIT DO
	IF CurrentX < (LEN(Startmenu$(2, I)) * 8) + 16 THEN
		IF CurrentX > 20 THEN
			IF CurrentY > 460 - (I * 17) THEN
				IF CurrentY < 460 - ((I * 17) - 17) THEN
					IF MousePressed = 1 THEN
						IF LEFT$(Startmenu$(2, I), 2) = "&d" THEN
							StartDir$ = StartDir$ + Startmenu$(2, I) + "\"
							ActivateMenu
						ELSE
							StartActive = 0
							RefWindows 1, -1
							execprog Startmenu$(2, I), 0, 0
							Waitfor .1
						END IF
					END IF
				END IF
			END IF
		END IF
	END IF
	LOOP
END IF
END SUB

SUB Scripter (PID)

Prognum = ProgManWithPid(PID)
IF Prognum > 0 THEN
OSL = VAL(LEFT$(LTRIM$(STR$(Programs(Prognum).OSL)), 1))
ELSE
ErrorNu 110, "SCRIPTER"
END IF
SELECT CASE OSL
	CASE 0: ExecLineProg PID
	CASE 1
	CASE 2
	CASE 3
		Secs = VAL(RIGHT$(TIME$, 2))
		secstart = VAL(RIGHT$(LTRIM$(RTRIM$(STR$(Programs(Prognum).OSL))), 2))
		SecWait = VAL(MID$(LTRIM$(RTRIM$(STR$(Programs(Prognum).OSL))), 2, LEN(LTRIM$(RTRIM$(STR$(Programs(Prognum).OSL)))) - 3))
		conditiona = Secs >= secstart + SecWait
		conditionb = Secs = (59 - secstart) + SecWait - 1
		IF conditiona OR conditionb THEN Programs(Prognum).OSL = 0
	CASE 4
	CASE 5
	IF windows(WinWithPID(PID)).TD = 1 THEN
		IF Choice$ <> "" THEN
		IF Choice$ = CHR$(13) THEN
			Programs(Prognum).OSL = 0
		ELSE
		IF Choice$ = "" THEN
			VarName$ = Variables$(PID, 0)
			VarValu PID, VarName$, Variable$
			IF LEN(Variable$) > 0 THEN
				Variable$ = LEFT$(Variable$, LEN(Variable$) - 1)
				SetVarVal PID, VarName$, Variable$
			ELSE
				BEEP
			END IF
		ELSE
			VarName$ = Variables$(PID, 0)
			VarValu PID, VarName$, value$
			value$ = value$ + Choice$
			SetVarVal PID, VarName$, value$
			VarValu PID, VarName$, Values$
			PrintToWin PID, RIGHT$(Values$, 1)
		END IF
		END IF
	END IF
	END IF
	CASE ELSE: ERROR 103
END SELECT

END SUB

SUB SetAttrib (FileName$, Oner$, UsrRead$, UsrWrite$, UsrDelete$)
AFreeFile = FREEFILE

flag = 0
OPEN "files.dat" FOR BINARY AS #AFreeFile
CLOSE #AFreeFile
OPEN "files.dat" FOR INPUT AS #AFreeFile
	DO
		INPUT #AFreeFile, NewLine$
		IF INSTR(NewLine$, FileName$ + "::") THEN
			flag = 1
			EXIT DO
		END IF
	LOOP WHILE NOT (EOF(AFreeFile))
CLOSE #AFreeFile

IF flag = 0 THEN
	OPEN "files.dat" FOR APPEND AS #AFreeFile
CLS
Perms$ = UsrRead$ + UsrWrite$ + UsrDelete$
PRINT "><"; Perms$
waitforinput

PRINT #AFreeFile, FileName$ + "::" + Oner$ + "::" + Perms$
	CLOSE #AFreeFile
END IF

END SUB

SUB SetVarVal (PID, Name$, NewValue$)
FOR I = 1 TO UBOUND(Variables$, 2)
	IF LCASE$(LTRIM$(LEFT$(Variables$(PID, I), LEN(Name$)))) = LCASE$(LTRIM$(Name$)) THEN
		SpaceAt = I
	END IF
NEXT
String1$ = LEFT$(Variables$(PID, SpaceAt), LEN(Name$) + 5)
String2$ = NewValue$
Variables$(PID, SpaceAt) = String1$ + String2$
END SUB

SUB SizeWindowX (PID)
x = WinWithPID(PID)
IF windows(x).maxed = false THEN
IF windows(x).mined = false THEN
	IF CurrentX < windows(x).PosX + windows(x).SizX + 4 THEN
		IF CurrentX > windows(x).PosX + windows(x).SizX - 2 THEN
			IF CurrentY < windows(x).PosY + windows(x).SizY THEN
				IF CurrentY > windows(x).PosY + 16 THEN

windows(x).TD = .5
CLS
DO
PXSIZE = windows(x).SizX
IF CurrentX - windows(x).PosX <= windows(x).MaxX THEN
	IF CurrentX - windows(x).PosX >= windows(x).MinX THEN
		windows(x).SizX = CurrentX - windows(x).PosX
	END IF
END IF
IF PXSIZE <> windows(x).SizX THEN
	LINE (windows(x).PosX, windows(x).PosY)-(windows(x).PosX + PXSIZE, windows(x).PosY + windows(x).SizY), 0, B
	LINE (windows(x).PosX, windows(x).PosY)-(windows(x).PosX + windows(x).SizX, windows(x).PosY + windows(x).SizY), 9, B
END IF
LOOP WHILE MousePressed = 1
CursorOff
RefWindows 1, -1
cursorON
				END IF
			END IF
		END IF
	END IF
END IF
END IF

END SUB

SUB SizeWindowY (PID)
x = WinWithPID(PID)
IF windows(x).maxed = false THEN
IF windows(x).mined = false THEN
	IF CurrentY < windows(x).PosY + windows(x).SizY + 4 THEN
		IF CurrentY > windows(x).PosY + windows(x).SizY - 2 THEN
			IF CurrentX < windows(x).PosX + windows(x).SizX THEN
				IF CurrentX > windows(x).PosX THEN

windows(x).TD = .5
CursorOff
CLS
DO
PYSIZE = windows(x).SizY
IF CurrentY <= windows(x).PosY + windows(x).MaxY THEN
	IF CurrentY >= windows(x).PosY + windows(x).MinY THEN
		windows(x).SizY = CurrentY - windows(x).PosY
	END IF
END IF
IF PYSIZE <> windows(x).SizY THEN
	LINE (windows(x).PosX, windows(x).PosY)-(windows(x).PosX + windows(x).SizX, windows(x).PosY + PYSIZE), 0, B
	LINE (windows(x).PosX, windows(x).PosY)-(windows(x).PosX + windows(x).SizX, windows(x).PosY + windows(x).SizY), 9, B
END IF
LOOP WHILE MousePressed = 1
RefWindows 1, -1
cursorON


				END IF
			END IF
		END IF
	END IF
END IF
END IF
END SUB

SUB StartUp (StartUpError, Username$, Password$)
	FileAccess$ = TGODrive$ + TGODirectory$ + "data.tgo"
	OpenF FileAccess$, "in", 0
	DO WHILE NOT (EOF(GetFnum(FileAccess$, 0)))
		 InputFrom FileAccess$, NameSearch$, 1
		 IF NameSearch$ = "*" THEN
			InputFrom FileAccess$, NameSearch$, 1
			IF NameSearch$ = Username$ THEN
				EXIT DO
			END IF
		 END IF
		 IF EOF(GetFnum(FileAccess$, 0)) THEN
			EofReached = true
			StartUpError = 1
		 END IF
	LOOP
	IF EOF(GetFnum(FileAccess$, 0)) THEN
		EofReached = true
		StartUpError = 1
	END IF
	IF EofReached = false THEN
		InputFrom FileAccess$, Mousyy$, 1
		InputFrom FileAccess$, TimeToSSActivate$, 1: Datastream.SSTimer = VAL(TimeToSSActivate$)
		InputFrom FileAccess$, ModemCom$, 1: Datastream.ModemCom = VAL(ModemCom$)
		InputFrom FileAccess$, CorrectPassword$, 1: CorrectPassword$ = LTRIM$(RTRIM$(CorrectPassword$))
		InputFrom FileAccess$, RealName$, 1
		InputFrom FileAccess$, Version$, 1
		InputFrom FileAccess$, redc$, 1: Datastream.redc = VAL(redc$)
		InputFrom FileAccess$, greenc$, 1: Datastream.greenc = VAL(greenc$)
		InputFrom FileAccess$, bluec$, 1: Datastream.bluec = VAL(bluec$)
		IF Password$ <> CorrectPassword$ THEN StartUpError = 2
	END IF
	CloseF FileAccess$
	FileAccess$ = ""
END SUB

SUB UnMaxWindow (PID)
	x = WinWithPID(PID)
	windows(x).maxed = 0
	windows(x).TD = .5
	RefWindows 1, -1
END SUB

'Optimizable By Making MIN/UNMIN One SUb
SUB UnMinWindow (PID)
	winnum = WinWithPID(PID)
	windows(winnum).mined = 0
	windows(winnum).TD = .5
	RefWindows 1, -1
END SUB

SUB UpdateDataFile

'This Sub Updates The Data File By Copying All The Data
'To A Temporary File, Except For The Current User's Data...
'Then Adding The Current User's Data, Then OverWriting The
'Actual File With The Temporary File's Contents, Then Destroying The
'Temporary File.

	OPEN TGODirectory$ + Datafile$ FOR INPUT AS #1
		OPEN TGODirectory$ + TempFile$ FOR OUTPUT AS #2
			DO
			LINE INPUT #1, DataStr$
			IF DataStr$ = "*" + Username$ THEN
				FOR x = 1 TO 9 + 1
					
					IF NOT (EOF(1)) THEN
					LINE INPUT #1, DataStr$
					END IF
				NEXT
			END IF
			WRITE #2, DataStr$
			LOOP WHILE (NOT EOF(1))
		CLOSE #2
	CLOSE #1

	OPEN TGODirectory$ + Datafile$ FOR OUTPUT AS #1
	PRINT #1, "*" + Username$
	PRINT #1, 1
	PRINT #1, STR$(Datastream.SSTimer)
	PRINT #1, STR$(Datastream.ModemCom)
	PRINT #1, Password$
	PRINT #1, Owner$
	PRINT #1, Version$
	PRINT #1, STR$(Datastream.redc)
	PRINT #1, STR$(Datastream.greenc)
	PRINT #1, STR$(Datastream.bluec)

	OPEN TGODirectory$ + TempFile$ FOR INPUT AS #2
		DO
		INPUT #2, DataVar$
		PRINT #1, DataVar$
		LOOP UNTIL EOF(2)
	CLOSE #2
	CLOSE #1

	KILL TGODirectory$ + TempFile$
			 
END SUB

SUB UpdateIniFile
OPEN TGODirectory$ + "tgo.ini" FOR OUTPUT AS #1

	PRINT #1, "[settings]"

	PRINT #1, "vers="; Version$
			 
	PRINT #1, "logo="; LTRIM$(RTRIM$(STR$(RunLogo)))
			 
	PRINT #1, "memr="; LTRIM$(RTRIM$(STR$(RunMem)))
			 
	PRINT #1, "data="; Datafile$
			 
	PRINT #1, "temp="; TempFile$
			 
	PRINT #1, "memo="; MemAddyFile$
			 
	PRINT #1, "[screensaver]"
			 
	PRINT #1, "file="; ScreenSaverFile$

	PRINT #1, "[graphics]"

	PRINT #1, "grad=" + LTRIM$(RTRIM$(STR$(grad)))
	
CLOSE #1

END SUB

SUB VarValu (PID, Name$, value$)

FOR I = 1 TO UBOUND(Variables$, 2)
	IF LCASE$(LEFT$(Variables$(PID, I), LEN(Name$))) = LCASE$(Name$) THEN
		Space = I
		EXIT FOR
	END IF
NEXT

IF I >= UBOUND(Variables$, 2) THEN
	CloseProgram PID, 0: RefWindows 1, -1
	ErrorNu 112, "VARVALU/Variable Name: " + Name$ + " Was Undeclared, And Accessed."
ELSE
	value$ = RIGHT$(Variables$(PID, I), LEN(Variables$(PID, I)) - (5 + LEN(Name$)))
END IF

END SUB

SUB Waitfor (Time!)

'This Sub Is A ShortCut Way Of Making A Quick
'Counter That Goes Into A Loop Until The
'X Number Of Seconds Are Up.
			 
	A! = TIMER
	DO
	LOOP UNTIL A! + Time! <= TIMER

END SUB

SUB waitforinput
	DO
	LOOP WHILE INKEY$ = ""
END SUB

FUNCTION WindowsGet$ (x, Labels$)

END FUNCTION

SUB WindowsSort
'TODO implement Linked List Verses Array
	 DO
		Changed = false
		FOR I = UBOUND(windows) TO 2 STEP -1
			IF windows(I).TD > 0 AND (windows(I - 1).TD = 0 OR windows(I - 1).TD > windows(I).TD) THEN
				SWAP windows(I), windows(I - 1)
				Changed = true
			END IF
		NEXT
	 LOOP UNTIL Changed = false

	 FOR I = 1 TO UBOUND(windows)
		 IF windows(I).TD > 0 AND windows(I).TD < UBOUND(windows) THEN
		 windows(I).TD = I
		 END IF
	 NEXT
END SUB

FUNCTION WinWithPID (PID)
	FOR I = 1 TO UBOUND(windows)
		IF windows(I).PID = PID THEN
			WinWithPID = I
			'PRINT "WIN WITH PID: "; PID, i
			EXIT FUNCTION
		END IF
	NEXT
END FUNCTION

